;;  Horn Clause Representation of Cubeo(Adr) Kinship Term-of-Address Rules

;;  The following 'header' gives some basic parameters of this kinship system:
(languageName, "Cubeo(Adr)") (author, "Nancy L. Morse") (date, "1985-01-01") (citation, "Nancy L. Morse in SOUTH AMERICAN KINSHIP pp. 79-91") 
(non_term, [aux], sibling, siblings, parents, children, brother, children, half_brother, half_sister, parents, sibling, siblings, sister, spice, step_brother, step_daughter, step_father, step_mother, step_sister, step_son) (partial, false) (polygamyOK, true) (address, true) (recursiveLevels, 1)
(synonyms, (pacu, bayu))
(overlaps, (ami_co, (juai_co, buchu)), (ami_yo, (juai_yo)), (buchu, (juai_co, juai_yo)), (chima, (parajicu)), (jicapenumu, (jicoyumu)), (jichimaco, (juai_co, parajico)), (jichimacu, (juai_yo, parajicu)), (jicoyumu, (jicapenumu)), (juai_co, (ami_co, buchu, jichimaco, parajico)), (juai_yo, (ami_yo, buchu, jichimacu, parajicu)), (paco, (parimo)), (pacu_yo, (pariyo)), (parajico, (jichimaco, juai_co)), (parajicu, (chima, jichimacu, juai_yo)), (parimo, (paco)), (pariyo, (pacu_yo)))
(umbrellas, (bucuru, (bucu, buco)), (juai_co, (parajico)), (juai_yo, (buchu, chima, parajicu)), (parimo, (pari_mo)), (pariyo, (pari_yo)))
(userDefinedProperties, 
	(*phratry, type, integer, single_value, true, restricted_to, (0, 1, 2, 3, 9)),
	(*sib_name, type, string, single_value, true, restricted_to, ("auwewa", "jejenawa", "bajucuwa", "pedicuwa", "wadariwa", "ijowedowa", "uchiwaiwa", "piarawa", "miadawa", "biowa", "corowa", "juruwa", "yuremawa", "yaniwa", "yocacubewu", "codeitarabuawu", "toruawu", "betowa")),
	(*sib_number, type, integer, single_value, true, restricted_to, (0, 11, 12, 13, 14, 15, 16, 17, 18, 21, 22, 23, 24, 31, 32, 33, 34, 35, 36, 90))
  )


;;  Kin Term Definitions:
;;	(Standard Macros are automatically incorporated.)

ami_co(Alter, Ego) :-  sister(Alter, Ego), elder(Alter, Ego).
                   |  [ext],  elder_para_gen[aux]10(Alter, Ego), female(Alter).
                   |  [ext],  female(Alter), *phratry(A, Ego), *phratry(A, Alter), *sib_number(B, Ego), *sib_number(C, Alter), lessThan(C, B), not(generation[aux]10(Alter, Ego)).
                   |  [ext],  female(Alter), *sib_number(A, Ego), *sib_number(A, Alter), not(equal(Ego, Alter)), elder(Alter, Ego), not(generation[aux]10(Alter, Ego)).
{"**_FaBroDa_FaHbroDa_Hsis_MoHsisDa_MoSisDa_Sis_StfaBroDa_StmoSisDa"}
;; 0
%ami_co:0, sister:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {Sis}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter), elder(Alter, Ego).
;; 1
%ami_co:1, elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {Sis}  
[ext],  mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Alter), gender(C, Ego), elder(Alter, Ego), female(Alter).
;; 2
%ami_co:1, elder_para_gen[aux]10:1, parents:0, elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoSisDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), elder(D, A), child(Alter, D), gender(F, A), gender(F, D), female(Alter).
;; 3
%ami_co:1, elder_para_gen[aux]10:1, parents:0, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=2, Star=0,  {MoHsisDa}  
[ext], [ext],  mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), elder(E, A), child(Alter, E), gender(G, A), gender(G, E), female(Alter).
;; 4
%ami_co:1, elder_para_gen[aux]10:1, parents:0, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=2, Star=0,  {MoHsisDa}  
[ext], [ext],  mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), elder(E, A), child(Alter, E), gender(G, A), gender(G, E), female(Alter).
;; 5
%ami_co:1, elder_para_gen[aux]10:1, parents:1, elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaBroDa}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), elder(D, A), child(Alter, D), gender(F, A), gender(F, D), female(Alter).
;; 6
%ami_co:1, elder_para_gen[aux]10:1, parents:1, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=2, Star=0,  {FaHbroDa}  
[ext], [ext],  father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), elder(E, A), child(Alter, E), gender(G, A), gender(G, E), female(Alter).
;; 7
%ami_co:1, elder_para_gen[aux]10:1, parents:1, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=2, Star=0,  {FaHbroDa}  
[ext], [ext],  father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), elder(E, A), child(Alter, E), gender(G, A), gender(G, E), female(Alter).
;; 8
%ami_co:1, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=3, S=2, Star=0,  {Hsis}  
[ext], [ext],  husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(Alter, B), gender(D, Alter), gender(D, Ego), elder(Alter, Ego), female(Alter).
;; 9
%ami_co:1, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=3, S=2, Star=0,  {Hsis}  
[ext], [ext],  wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(Alter, B), gender(D, Alter), gender(D, Ego), elder(Alter, Ego), female(Alter).
;; 10
%ami_co:1, elder_para_gen[aux]10:3, step_child[aux]10:0, spice:0, elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=2, Star=0,  {StmoSisDa}  
[ext], [ext],  husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), elder(F, B), child(Alter, F), gender(H, B), gender(H, F), female(Alter).
;; 11
%ami_co:1, elder_para_gen[aux]10:3, step_child[aux]10:0, spice:1, elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=2, Star=0,  {StfaBroDa}  
[ext], [ext],  wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), elder(F, B), child(Alter, F), gender(H, B), gender(H, F), female(Alter).
;; 12
%ami_co:2, (not: generation[aux]10:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1)%
 Lvl=0,  PC=0, S=0, Star=0,  {**}  
[ext],  female(Alter), *phratry(A, Ego), *phratry(A, Alter), *sib_number(B, Ego), *sib_number(C, Alter), lessThan(C, B), not(mother(D, Ego), father(E, Ego), child(Alter, D), child(Alter, E), not(equal(Alter, Ego))), not(mother(F, Ego), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), child(Alter, I)), not(mother(F, Ego), mother(J, F), father(K, F), child(I, J), child(I, K), not(equal(I, F)), female(I), child(Alter, I)), not(mother(F, Ego), mother(L, F), mother(M, L), father(N, L), child(O, M), child(O, N), not(equal(O, L)), male(O), son(I, O), child(Alter, I)), not(mother(F, Ego), mother(L, F), mother(M, L), father(N, L), child(O, M), child(O, N), not(equal(O, L)), male(O), daughter(I, O), child(Alter, I)), not(mother(F, Ego), mother(L, F), mother(P, L), father(Q, L), child(O, P), child(O, Q), not(equal(O, L)), female(O), son(I, O), child(Alter, I)), not(mother(F, Ego), mother(L, F), mother(P, L), father(Q, L), child(O, P), child(O, Q), not(equal(O, L)), female(O), daughter(I, O), child(Alter, I)), not(mother(F, Ego), father(L, F), mother(R, L), father(S, L), child(O, R), child(O, S), not(equal(O, L)), male(O), son(I, O), child(Alter, I)), not(mother(F, Ego), father(L, F), mother(R, L), father(S, L), child(O, R), child(O, S), not(equal(O, L)), male(O), daughter(I, O), child(Alter, I)), not(mother(F, Ego), father(L, F), mother(T, L), father(U, L), child(O, T), child(O, U), not(equal(O, L)), female(O), son(I, O), child(Alter, I)), not(mother(F, Ego), father(L, F), mother(T, L), father(U, L), child(O, T), child(O, U), not(equal(O, L)), female(O), daughter(I, O), child(Alter, I)), not(father(F, Ego), mother(V, F), father(W, F), child(I, V), child(I, W), not(equal(I, F)), male(I), child(Alter, I)), not(father(F, Ego), mother(X, F), father(Y, F), child(I, X), child(I, Y), not(equal(I, F)), female(I), child(Alter, I)), not(father(F, Ego), mother(Z, F), mother(AA, Z), father(BB, Z), child(CC, AA), child(CC, BB), not(equal(CC, Z)), male(CC), son(I, CC), child(Alter, I)), not(father(F, Ego), mother(Z, F), mother(AA, Z), father(BB, Z), child(CC, AA), child(CC, BB), not(equal(CC, Z)), male(CC), daughter(I, CC), child(Alter, I)), not(father(F, Ego), mother(Z, F), mother(DD, Z), father(EE, Z), child(CC, DD), child(CC, EE), not(equal(CC, Z)), female(CC), son(I, CC), child(Alter, I)), not(father(F, Ego), mother(Z, F), mother(DD, Z), father(EE, Z), child(CC, DD), child(CC, EE), not(equal(CC, Z)), female(CC), daughter(I, CC), child(Alter, I)), not(father(F, Ego), father(Z, F), mother(FF, Z), father(GG, Z), child(CC, FF), child(CC, GG), not(equal(CC, Z)), male(CC), son(I, CC), child(Alter, I)), not(father(F, Ego), father(Z, F), mother(FF, Z), father(GG, Z), child(CC, FF), child(CC, GG), not(equal(CC, Z)), male(CC), daughter(I, CC), child(Alter, I)), not(father(F, Ego), father(Z, F), mother(HH, Z), father(II, Z), child(CC, HH), child(CC, II), not(equal(CC, Z)), female(CC), son(I, CC), child(Alter, I)), not(father(F, Ego), father(Z, F), mother(HH, Z), father(II, Z), child(CC, HH), child(CC, II), not(equal(CC, Z)), female(CC), daughter(I, CC), child(Alter, I)).
;; 13
%ami_co:3, (not: generation[aux]10:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1)%
 Lvl=0,  PC=0, S=0, Star=2,  {**}  
[ext],  female(Alter), *sib_number(A, Ego), *sib_number(A, Alter), not(equal(Ego, Alter)), elder(Alter, Ego), not(mother(B, Ego), father(C, Ego), child(Alter, B), child(Alter, C), not(equal(Alter, Ego))), not(mother(D, Ego), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G)), not(mother(D, Ego), mother(H, D), father(I, D), child(G, H), child(G, I), not(equal(G, D)), female(G), child(Alter, G)), not(mother(D, Ego), mother(J, D), mother(K, J), father(L, J), child(M, K), child(M, L), not(equal(M, J)), male(M), son(G, M), child(Alter, G)), not(mother(D, Ego), mother(J, D), mother(K, J), father(L, J), child(M, K), child(M, L), not(equal(M, J)), male(M), daughter(G, M), child(Alter, G)), not(mother(D, Ego), mother(J, D), mother(N, J), father(O, J), child(M, N), child(M, O), not(equal(M, J)), female(M), son(G, M), child(Alter, G)), not(mother(D, Ego), mother(J, D), mother(N, J), father(O, J), child(M, N), child(M, O), not(equal(M, J)), female(M), daughter(G, M), child(Alter, G)), not(mother(D, Ego), father(J, D), mother(P, J), father(Q, J), child(M, P), child(M, Q), not(equal(M, J)), male(M), son(G, M), child(Alter, G)), not(mother(D, Ego), father(J, D), mother(P, J), father(Q, J), child(M, P), child(M, Q), not(equal(M, J)), male(M), daughter(G, M), child(Alter, G)), not(mother(D, Ego), father(J, D), mother(R, J), father(S, J), child(M, R), child(M, S), not(equal(M, J)), female(M), son(G, M), child(Alter, G)), not(mother(D, Ego), father(J, D), mother(R, J), father(S, J), child(M, R), child(M, S), not(equal(M, J)), female(M), daughter(G, M), child(Alter, G)), not(father(D, Ego), mother(T, D), father(U, D), child(G, T), child(G, U), not(equal(G, D)), male(G), child(Alter, G)), not(father(D, Ego), mother(V, D), father(W, D), child(G, V), child(G, W), not(equal(G, D)), female(G), child(Alter, G)), not(father(D, Ego), mother(X, D), mother(Y, X), father(Z, X), child(AA, Y), child(AA, Z), not(equal(AA, X)), male(AA), son(G, AA), child(Alter, G)), not(father(D, Ego), mother(X, D), mother(Y, X), father(Z, X), child(AA, Y), child(AA, Z), not(equal(AA, X)), male(AA), daughter(G, AA), child(Alter, G)), not(father(D, Ego), mother(X, D), mother(BB, X), father(CC, X), child(AA, BB), child(AA, CC), not(equal(AA, X)), female(AA), son(G, AA), child(Alter, G)), not(father(D, Ego), mother(X, D), mother(BB, X), father(CC, X), child(AA, BB), child(AA, CC), not(equal(AA, X)), female(AA), daughter(G, AA), child(Alter, G)), not(father(D, Ego), father(X, D), mother(DD, X), father(EE, X), child(AA, DD), child(AA, EE), not(equal(AA, X)), male(AA), son(G, AA), child(Alter, G)), not(father(D, Ego), father(X, D), mother(DD, X), father(EE, X), child(AA, DD), child(AA, EE), not(equal(AA, X)), male(AA), daughter(G, AA), child(Alter, G)), not(father(D, Ego), father(X, D), mother(FF, X), father(GG, X), child(AA, FF), child(AA, GG), not(equal(AA, X)), female(AA), son(G, AA), child(Alter, G)), not(father(D, Ego), father(X, D), mother(FF, X), father(GG, X), child(AA, FF), child(AA, GG), not(equal(AA, X)), female(AA), daughter(G, AA), child(Alter, G)).


ami_yo(Alter, Ego) :-  brother(Alter, Ego), elder(Alter, Ego).
                   |  [ext],  elder_para_gen[aux]10(Alter, Ego), male(Alter).
                   |  [ext],  male(Alter), *phratry(A, Ego), *phratry(A, Alter), *sib_number(B, Ego), *sib_number(C, Alter), lessThan(C, B), not(generation[aux]10(Alter, Ego)).
                   |  [ext],  male(Alter), *sib_number(A, Ego), *sib_number(A, Alter), not(equal(Ego, Alter)), elder(Alter, Ego), not(generation[aux]10(Alter, Ego)).
{"**"}
;; 0
%ami_yo:0, brother:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {**}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter), elder(Alter, Ego).
;; 1
%ami_yo:1, elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Alter), gender(C, Ego), elder(Alter, Ego), male(Alter).
;; 2
%ami_yo:1, elder_para_gen[aux]10:1, parents:0, elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), elder(D, A), child(Alter, D), gender(F, A), gender(F, D), male(Alter).
;; 3
%ami_yo:1, elder_para_gen[aux]10:1, parents:0, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), elder(E, A), child(Alter, E), gender(G, A), gender(G, E), male(Alter).
;; 4
%ami_yo:1, elder_para_gen[aux]10:1, parents:0, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), elder(E, A), child(Alter, E), gender(G, A), gender(G, E), male(Alter).
;; 5
%ami_yo:1, elder_para_gen[aux]10:1, parents:1, elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), elder(D, A), child(Alter, D), gender(F, A), gender(F, D), male(Alter).
;; 6
%ami_yo:1, elder_para_gen[aux]10:1, parents:1, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), elder(E, A), child(Alter, E), gender(G, A), gender(G, E), male(Alter).
;; 7
%ami_yo:1, elder_para_gen[aux]10:1, parents:1, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), elder(E, A), child(Alter, E), gender(G, A), gender(G, E), male(Alter).
;; 8
%ami_yo:1, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=3, S=2, Star=0,  {**}  
[ext], [ext],  husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(Alter, B), gender(D, Alter), gender(D, Ego), elder(Alter, Ego), male(Alter).
;; 9
%ami_yo:1, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=3, S=2, Star=0,  {**}  
[ext], [ext],  wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(Alter, B), gender(D, Alter), gender(D, Ego), elder(Alter, Ego), male(Alter).
;; 10
%ami_yo:1, elder_para_gen[aux]10:3, step_child[aux]10:0, spice:0, elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), elder(F, B), child(Alter, F), gender(H, B), gender(H, F), male(Alter).
;; 11
%ami_yo:1, elder_para_gen[aux]10:3, step_child[aux]10:0, spice:1, elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), elder(F, B), child(Alter, F), gender(H, B), gender(H, F), male(Alter).
;; 12
%ami_yo:2, (not: generation[aux]10:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1)%
 Lvl=0,  PC=0, S=0, Star=0,  {**}  
[ext],  male(Alter), *phratry(A, Ego), *phratry(A, Alter), *sib_number(B, Ego), *sib_number(C, Alter), lessThan(C, B), not(mother(D, Ego), father(E, Ego), child(Alter, D), child(Alter, E), not(equal(Alter, Ego))), not(mother(F, Ego), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), child(Alter, I)), not(mother(F, Ego), mother(J, F), father(K, F), child(I, J), child(I, K), not(equal(I, F)), female(I), child(Alter, I)), not(mother(F, Ego), mother(L, F), mother(M, L), father(N, L), child(O, M), child(O, N), not(equal(O, L)), male(O), son(I, O), child(Alter, I)), not(mother(F, Ego), mother(L, F), mother(M, L), father(N, L), child(O, M), child(O, N), not(equal(O, L)), male(O), daughter(I, O), child(Alter, I)), not(mother(F, Ego), mother(L, F), mother(P, L), father(Q, L), child(O, P), child(O, Q), not(equal(O, L)), female(O), son(I, O), child(Alter, I)), not(mother(F, Ego), mother(L, F), mother(P, L), father(Q, L), child(O, P), child(O, Q), not(equal(O, L)), female(O), daughter(I, O), child(Alter, I)), not(mother(F, Ego), father(L, F), mother(R, L), father(S, L), child(O, R), child(O, S), not(equal(O, L)), male(O), son(I, O), child(Alter, I)), not(mother(F, Ego), father(L, F), mother(R, L), father(S, L), child(O, R), child(O, S), not(equal(O, L)), male(O), daughter(I, O), child(Alter, I)), not(mother(F, Ego), father(L, F), mother(T, L), father(U, L), child(O, T), child(O, U), not(equal(O, L)), female(O), son(I, O), child(Alter, I)), not(mother(F, Ego), father(L, F), mother(T, L), father(U, L), child(O, T), child(O, U), not(equal(O, L)), female(O), daughter(I, O), child(Alter, I)), not(father(F, Ego), mother(V, F), father(W, F), child(I, V), child(I, W), not(equal(I, F)), male(I), child(Alter, I)), not(father(F, Ego), mother(X, F), father(Y, F), child(I, X), child(I, Y), not(equal(I, F)), female(I), child(Alter, I)), not(father(F, Ego), mother(Z, F), mother(AA, Z), father(BB, Z), child(CC, AA), child(CC, BB), not(equal(CC, Z)), male(CC), son(I, CC), child(Alter, I)), not(father(F, Ego), mother(Z, F), mother(AA, Z), father(BB, Z), child(CC, AA), child(CC, BB), not(equal(CC, Z)), male(CC), daughter(I, CC), child(Alter, I)), not(father(F, Ego), mother(Z, F), mother(DD, Z), father(EE, Z), child(CC, DD), child(CC, EE), not(equal(CC, Z)), female(CC), son(I, CC), child(Alter, I)), not(father(F, Ego), mother(Z, F), mother(DD, Z), father(EE, Z), child(CC, DD), child(CC, EE), not(equal(CC, Z)), female(CC), daughter(I, CC), child(Alter, I)), not(father(F, Ego), father(Z, F), mother(FF, Z), father(GG, Z), child(CC, FF), child(CC, GG), not(equal(CC, Z)), male(CC), son(I, CC), child(Alter, I)), not(father(F, Ego), father(Z, F), mother(FF, Z), father(GG, Z), child(CC, FF), child(CC, GG), not(equal(CC, Z)), male(CC), daughter(I, CC), child(Alter, I)), not(father(F, Ego), father(Z, F), mother(HH, Z), father(II, Z), child(CC, HH), child(CC, II), not(equal(CC, Z)), female(CC), son(I, CC), child(Alter, I)), not(father(F, Ego), father(Z, F), mother(HH, Z), father(II, Z), child(CC, HH), child(CC, II), not(equal(CC, Z)), female(CC), daughter(I, CC), child(Alter, I)).
;; 13
%ami_yo:3, (not: generation[aux]10:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1)%
 Lvl=0,  PC=0, S=0, Star=2,  {**}  
[ext],  male(Alter), *sib_number(A, Ego), *sib_number(A, Alter), not(equal(Ego, Alter)), elder(Alter, Ego), not(mother(B, Ego), father(C, Ego), child(Alter, B), child(Alter, C), not(equal(Alter, Ego))), not(mother(D, Ego), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G)), not(mother(D, Ego), mother(H, D), father(I, D), child(G, H), child(G, I), not(equal(G, D)), female(G), child(Alter, G)), not(mother(D, Ego), mother(J, D), mother(K, J), father(L, J), child(M, K), child(M, L), not(equal(M, J)), male(M), son(G, M), child(Alter, G)), not(mother(D, Ego), mother(J, D), mother(K, J), father(L, J), child(M, K), child(M, L), not(equal(M, J)), male(M), daughter(G, M), child(Alter, G)), not(mother(D, Ego), mother(J, D), mother(N, J), father(O, J), child(M, N), child(M, O), not(equal(M, J)), female(M), son(G, M), child(Alter, G)), not(mother(D, Ego), mother(J, D), mother(N, J), father(O, J), child(M, N), child(M, O), not(equal(M, J)), female(M), daughter(G, M), child(Alter, G)), not(mother(D, Ego), father(J, D), mother(P, J), father(Q, J), child(M, P), child(M, Q), not(equal(M, J)), male(M), son(G, M), child(Alter, G)), not(mother(D, Ego), father(J, D), mother(P, J), father(Q, J), child(M, P), child(M, Q), not(equal(M, J)), male(M), daughter(G, M), child(Alter, G)), not(mother(D, Ego), father(J, D), mother(R, J), father(S, J), child(M, R), child(M, S), not(equal(M, J)), female(M), son(G, M), child(Alter, G)), not(mother(D, Ego), father(J, D), mother(R, J), father(S, J), child(M, R), child(M, S), not(equal(M, J)), female(M), daughter(G, M), child(Alter, G)), not(father(D, Ego), mother(T, D), father(U, D), child(G, T), child(G, U), not(equal(G, D)), male(G), child(Alter, G)), not(father(D, Ego), mother(V, D), father(W, D), child(G, V), child(G, W), not(equal(G, D)), female(G), child(Alter, G)), not(father(D, Ego), mother(X, D), mother(Y, X), father(Z, X), child(AA, Y), child(AA, Z), not(equal(AA, X)), male(AA), son(G, AA), child(Alter, G)), not(father(D, Ego), mother(X, D), mother(Y, X), father(Z, X), child(AA, Y), child(AA, Z), not(equal(AA, X)), male(AA), daughter(G, AA), child(Alter, G)), not(father(D, Ego), mother(X, D), mother(BB, X), father(CC, X), child(AA, BB), child(AA, CC), not(equal(AA, X)), female(AA), son(G, AA), child(Alter, G)), not(father(D, Ego), mother(X, D), mother(BB, X), father(CC, X), child(AA, BB), child(AA, CC), not(equal(AA, X)), female(AA), daughter(G, AA), child(Alter, G)), not(father(D, Ego), father(X, D), mother(DD, X), father(EE, X), child(AA, DD), child(AA, EE), not(equal(AA, X)), male(AA), son(G, AA), child(Alter, G)), not(father(D, Ego), father(X, D), mother(DD, X), father(EE, X), child(AA, DD), child(AA, EE), not(equal(AA, X)), male(AA), daughter(G, AA), child(Alter, G)), not(father(D, Ego), father(X, D), mother(FF, X), father(GG, X), child(AA, FF), child(AA, GG), not(equal(AA, X)), female(AA), son(G, AA), child(Alter, G)), not(father(D, Ego), father(X, D), mother(FF, X), father(GG, X), child(AA, FF), child(AA, GG), not(equal(AA, X)), female(AA), daughter(G, AA), child(Alter, G)).


baco(Alter, Ego) :-  mother(Alter, Ego).
{"Mo"}
;; 0
%baco:0%
 Lvl=1,  PC=1, S=0, Star=0,  {Mo}  
 mother(Alter, Ego).


bayu(Alter, Ego) :-  father(Alter, Ego).
;; 0
%bayu:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(Alter, Ego).


brother(Alter, Ego) :-  sibling(Alter, Ego), male(Alter).
;; 0
%brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter).


buchu(Alter, Ego) :-  siblings(Alter, Ego), younger(Alter, Ego).
                  |  [ext],  *phratry(A, Ego), *phratry(A, Alter), *sib_number(B, Ego), *sib_number(C, Alter), lessThan(B, C), not(generation[aux]10(Alter, Ego)).
                  |  [ext],  *sib_number(A, Ego), *sib_number(A, Alter), not(equal(Ego, Alter)), elder(Ego, Alter), not(generation[aux]10(Alter, Ego)).
{"**_Sis"}
;; 0
%buchu:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {**}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter), younger(Alter, Ego).
;; 1
%buchu:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {Sis}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter), younger(Alter, Ego).
;; 2
%buchu:1, (not: generation[aux]10:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1)%
 Lvl=0,  PC=0, S=0, Star=4,  {**}  
[ext],  *phratry(A, Ego), *phratry(A, Alter), *sib_number(B, Ego), *sib_number(C, Alter), lessThan(B, C), not(mother(D, Ego), father(E, Ego), child(Alter, D), child(Alter, E), not(equal(Alter, Ego))), not(mother(F, Ego), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), child(Alter, I)), not(mother(F, Ego), mother(J, F), father(K, F), child(I, J), child(I, K), not(equal(I, F)), female(I), child(Alter, I)), not(mother(F, Ego), mother(L, F), mother(M, L), father(N, L), child(O, M), child(O, N), not(equal(O, L)), male(O), son(I, O), child(Alter, I)), not(mother(F, Ego), mother(L, F), mother(M, L), father(N, L), child(O, M), child(O, N), not(equal(O, L)), male(O), daughter(I, O), child(Alter, I)), not(mother(F, Ego), mother(L, F), mother(P, L), father(Q, L), child(O, P), child(O, Q), not(equal(O, L)), female(O), son(I, O), child(Alter, I)), not(mother(F, Ego), mother(L, F), mother(P, L), father(Q, L), child(O, P), child(O, Q), not(equal(O, L)), female(O), daughter(I, O), child(Alter, I)), not(mother(F, Ego), father(L, F), mother(R, L), father(S, L), child(O, R), child(O, S), not(equal(O, L)), male(O), son(I, O), child(Alter, I)), not(mother(F, Ego), father(L, F), mother(R, L), father(S, L), child(O, R), child(O, S), not(equal(O, L)), male(O), daughter(I, O), child(Alter, I)), not(mother(F, Ego), father(L, F), mother(T, L), father(U, L), child(O, T), child(O, U), not(equal(O, L)), female(O), son(I, O), child(Alter, I)), not(mother(F, Ego), father(L, F), mother(T, L), father(U, L), child(O, T), child(O, U), not(equal(O, L)), female(O), daughter(I, O), child(Alter, I)), not(father(F, Ego), mother(V, F), father(W, F), child(I, V), child(I, W), not(equal(I, F)), male(I), child(Alter, I)), not(father(F, Ego), mother(X, F), father(Y, F), child(I, X), child(I, Y), not(equal(I, F)), female(I), child(Alter, I)), not(father(F, Ego), mother(Z, F), mother(AA, Z), father(BB, Z), child(CC, AA), child(CC, BB), not(equal(CC, Z)), male(CC), son(I, CC), child(Alter, I)), not(father(F, Ego), mother(Z, F), mother(AA, Z), father(BB, Z), child(CC, AA), child(CC, BB), not(equal(CC, Z)), male(CC), daughter(I, CC), child(Alter, I)), not(father(F, Ego), mother(Z, F), mother(DD, Z), father(EE, Z), child(CC, DD), child(CC, EE), not(equal(CC, Z)), female(CC), son(I, CC), child(Alter, I)), not(father(F, Ego), mother(Z, F), mother(DD, Z), father(EE, Z), child(CC, DD), child(CC, EE), not(equal(CC, Z)), female(CC), daughter(I, CC), child(Alter, I)), not(father(F, Ego), father(Z, F), mother(FF, Z), father(GG, Z), child(CC, FF), child(CC, GG), not(equal(CC, Z)), male(CC), son(I, CC), child(Alter, I)), not(father(F, Ego), father(Z, F), mother(FF, Z), father(GG, Z), child(CC, FF), child(CC, GG), not(equal(CC, Z)), male(CC), daughter(I, CC), child(Alter, I)), not(father(F, Ego), father(Z, F), mother(HH, Z), father(II, Z), child(CC, HH), child(CC, II), not(equal(CC, Z)), female(CC), son(I, CC), child(Alter, I)), not(father(F, Ego), father(Z, F), mother(HH, Z), father(II, Z), child(CC, HH), child(CC, II), not(equal(CC, Z)), female(CC), daughter(I, CC), child(Alter, I)).
;; 3
%buchu:2, (not: generation[aux]10:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1)%
 Lvl=0,  PC=0, S=0, Star=2,  {**}  
[ext],  *sib_number(A, Ego), *sib_number(A, Alter), not(equal(Ego, Alter)), elder(Ego, Alter), not(mother(B, Ego), father(C, Ego), child(Alter, B), child(Alter, C), not(equal(Alter, Ego))), not(mother(D, Ego), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G)), not(mother(D, Ego), mother(H, D), father(I, D), child(G, H), child(G, I), not(equal(G, D)), female(G), child(Alter, G)), not(mother(D, Ego), mother(J, D), mother(K, J), father(L, J), child(M, K), child(M, L), not(equal(M, J)), male(M), son(G, M), child(Alter, G)), not(mother(D, Ego), mother(J, D), mother(K, J), father(L, J), child(M, K), child(M, L), not(equal(M, J)), male(M), daughter(G, M), child(Alter, G)), not(mother(D, Ego), mother(J, D), mother(N, J), father(O, J), child(M, N), child(M, O), not(equal(M, J)), female(M), son(G, M), child(Alter, G)), not(mother(D, Ego), mother(J, D), mother(N, J), father(O, J), child(M, N), child(M, O), not(equal(M, J)), female(M), daughter(G, M), child(Alter, G)), not(mother(D, Ego), father(J, D), mother(P, J), father(Q, J), child(M, P), child(M, Q), not(equal(M, J)), male(M), son(G, M), child(Alter, G)), not(mother(D, Ego), father(J, D), mother(P, J), father(Q, J), child(M, P), child(M, Q), not(equal(M, J)), male(M), daughter(G, M), child(Alter, G)), not(mother(D, Ego), father(J, D), mother(R, J), father(S, J), child(M, R), child(M, S), not(equal(M, J)), female(M), son(G, M), child(Alter, G)), not(mother(D, Ego), father(J, D), mother(R, J), father(S, J), child(M, R), child(M, S), not(equal(M, J)), female(M), daughter(G, M), child(Alter, G)), not(father(D, Ego), mother(T, D), father(U, D), child(G, T), child(G, U), not(equal(G, D)), male(G), child(Alter, G)), not(father(D, Ego), mother(V, D), father(W, D), child(G, V), child(G, W), not(equal(G, D)), female(G), child(Alter, G)), not(father(D, Ego), mother(X, D), mother(Y, X), father(Z, X), child(AA, Y), child(AA, Z), not(equal(AA, X)), male(AA), son(G, AA), child(Alter, G)), not(father(D, Ego), mother(X, D), mother(Y, X), father(Z, X), child(AA, Y), child(AA, Z), not(equal(AA, X)), male(AA), daughter(G, AA), child(Alter, G)), not(father(D, Ego), mother(X, D), mother(BB, X), father(CC, X), child(AA, BB), child(AA, CC), not(equal(AA, X)), female(AA), son(G, AA), child(Alter, G)), not(father(D, Ego), mother(X, D), mother(BB, X), father(CC, X), child(AA, BB), child(AA, CC), not(equal(AA, X)), female(AA), daughter(G, AA), child(Alter, G)), not(father(D, Ego), father(X, D), mother(DD, X), father(EE, X), child(AA, DD), child(AA, EE), not(equal(AA, X)), male(AA), son(G, AA), child(Alter, G)), not(father(D, Ego), father(X, D), mother(DD, X), father(EE, X), child(AA, DD), child(AA, EE), not(equal(AA, X)), male(AA), daughter(G, AA), child(Alter, G)), not(father(D, Ego), father(X, D), mother(FF, X), father(GG, X), child(AA, FF), child(AA, GG), not(equal(AA, X)), female(AA), son(G, AA), child(Alter, G)), not(father(D, Ego), father(X, D), mother(FF, X), father(GG, X), child(AA, FF), child(AA, GG), not(equal(AA, X)), female(AA), daughter(G, AA), child(Alter, G)).


buco(Alter, Ego) :-  daughter(Alter, Ego).
{"**"}
;; 0
%buco:0%
 Lvl=-1,  PC=1, S=0, Star=0,  {**}  
 daughter(Alter, Ego).


bucu(Alter, Ego) :-  son(Alter, Ego).
{"**"}
;; 0
%bucu:0%
 Lvl=-1,  PC=1, S=0, Star=0,  {**}  
 son(Alter, Ego).


bucuru(Alter, Ego) :-  children(Alter, Ego).
{"**"}
;; 0
%bucuru:0, children:0%
 Lvl=-1,  PC=1, S=0, Star=0,  {**}  
 son(Alter, Ego).
;; 1
%bucuru:0, children:1%
 Lvl=-1,  PC=1, S=0, Star=0,  {**}  
 daughter(Alter, Ego).


child_in_law[aux]10(Alter, Ego) :-  child(A, Ego), spouse(Alter, A).
                                |  [ext],  spice(A, Ego), spouse(B, A), not(equal(Ego, B)), child(C, B), child(C, A), spouse(Alter, C).
                                |  [ext],  children(A, Ego), spouse(B, A), generation[aux]10(Alter, B).
                                |  [ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), children(C, B), child(C, A), spouse(D, C), generation[aux]10(Alter, D).
;; 0
%child_in_law[aux]10:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 child(A, Ego), spouse(Alter, A).
;; 1
%child_in_law[aux]10:1, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), spouse(B, A), not(equal(Ego, B)), child(C, B), child(C, A), spouse(Alter, C).
;; 2
%child_in_law[aux]10:1, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), spouse(B, A), not(equal(Ego, B)), child(C, B), child(C, A), spouse(Alter, C).
;; 3
%child_in_law[aux]10:2, children:0, generation[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 4
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 5
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 6
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 7
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 8
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 9
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 10
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 11
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 12
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 13
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 14
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 15
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 16
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 17
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 18
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 19
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 20
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 21
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 22
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 23
%child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  son(A, Ego), spouse(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 24
%child_in_law[aux]10:2, children:1, generation[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 25
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 26
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 27
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 28
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 29
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 30
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 31
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 32
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 33
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 34
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 35
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 36
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 37
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 38
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 39
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 40
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 41
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 42
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 43
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 44
%child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  daughter(A, Ego), spouse(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 45
%child_in_law[aux]10:3, children:0, generation[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 46
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H).
;; 47
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H).
;; 48
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J).
;; 49
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J).
;; 50
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J).
;; 51
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J).
;; 52
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J).
;; 53
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J).
;; 54
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J).
;; 55
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J).
;; 56
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H).
;; 57
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H).
;; 58
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J).
;; 59
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J).
;; 60
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J).
;; 61
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J).
;; 62
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J).
;; 63
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J).
;; 64
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J).
;; 65
%child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J).
;; 66
%child_in_law[aux]10:3, children:1, generation[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 67
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H).
;; 68
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H).
;; 69
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J).
;; 70
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J).
;; 71
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J).
;; 72
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J).
;; 73
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J).
;; 74
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J).
;; 75
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J).
;; 76
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J).
;; 77
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H).
;; 78
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H).
;; 79
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J).
;; 80
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J).
;; 81
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J).
;; 82
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J).
;; 83
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J).
;; 84
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J).
;; 85
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J).
;; 86
%child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J).


children(Alter, Ego) :-  son(Alter, Ego).
                     |   daughter(Alter, Ego).
;; 0
%children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(Alter, Ego).
;; 1
%children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(Alter, Ego).


chima(Alter, Ego) :-  male(Ego), cross_gen[aux]102(Alter, Ego), male(Alter).
                  |   male(Ego), cross_gen[aux]102(A, Ego), parents(A, Alter), male(Alter).
                  |   male(Ego), cross_gen[aux]102(A, Ego), parents(A, B), parents(B, Alter), male(Alter).
{"**"}
;; 0
%chima:0, cross_gen[aux]102:0, parents:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C), male(Alter).
;; 1
%chima:0, cross_gen[aux]102:0, parents:1, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C), male(Alter).
;; 2
%chima:0, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H), male(Alter).
;; 3
%chima:0, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H), male(Alter).
;; 4
%chima:0, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H), male(Alter).
;; 5
%chima:0, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H), male(Alter).
;; 6
%chima:0, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H), male(Alter).
;; 7
%chima:0, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H), male(Alter).
;; 8
%chima:0, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H), male(Alter).
;; 9
%chima:0, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H), male(Alter).
;; 10
%chima:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)), male(Alter).
;; 11
%chima:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 12
%chima:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 13
%chima:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 14
%chima:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 15
%chima:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 16
%chima:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 17
%chima:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 18
%chima:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 19
%chima:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)), male(Alter).
;; 20
%chima:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 21
%chima:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 22
%chima:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 23
%chima:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 24
%chima:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 25
%chima:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 26
%chima:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 27
%chima:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 28
%chima:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)), male(Alter).
;; 29
%chima:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 30
%chima:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 31
%chima:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 32
%chima:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 33
%chima:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 34
%chima:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 35
%chima:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 36
%chima:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 37
%chima:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)), male(Alter).
;; 38
%chima:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 39
%chima:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 40
%chima:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 41
%chima:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 42
%chima:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 43
%chima:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 44
%chima:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 45
%chima:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 46
%chima:1, cross_gen[aux]102:0, parents:0, sibling:0, parents:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, Alter), male(Alter).
;; 47
%chima:1, cross_gen[aux]102:0, parents:0, sibling:0, parents:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, Alter), male(Alter).
;; 48
%chima:1, cross_gen[aux]102:0, parents:1, sibling:0, parents:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, Alter), male(Alter).
;; 49
%chima:1, cross_gen[aux]102:0, parents:1, sibling:0, parents:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, Alter), male(Alter).
;; 50
%chima:1, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 51
%chima:1, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, Alter), male(Alter).
;; 52
%chima:1, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 53
%chima:1, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, Alter), male(Alter).
;; 54
%chima:1, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 55
%chima:1, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, Alter), male(Alter).
;; 56
%chima:1, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 57
%chima:1, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, Alter), male(Alter).
;; 58
%chima:1, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 59
%chima:1, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, Alter), male(Alter).
;; 60
%chima:1, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 61
%chima:1, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, Alter), male(Alter).
;; 62
%chima:1, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 63
%chima:1, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, Alter), male(Alter).
;; 64
%chima:1, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 65
%chima:1, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, Alter), male(Alter).
;; 66
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), mother(H, Alter), male(Alter).
;; 67
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), father(H, Alter), male(Alter).
;; 68
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 69
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 70
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 71
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 72
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 73
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 74
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 75
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 76
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 77
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 78
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 79
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 80
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 81
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 82
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 83
%chima:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 84
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), mother(H, Alter), male(Alter).
;; 85
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), father(H, Alter), male(Alter).
;; 86
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 87
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 88
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 89
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 90
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 91
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 92
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 93
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 94
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 95
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 96
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 97
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 98
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 99
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 100
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 101
%chima:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 102
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), mother(H, Alter), male(Alter).
;; 103
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), father(H, Alter), male(Alter).
;; 104
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 105
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 106
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 107
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 108
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 109
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 110
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 111
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 112
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 113
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 114
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 115
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 116
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 117
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 118
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 119
%chima:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 120
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), mother(H, Alter), male(Alter).
;; 121
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), father(H, Alter), male(Alter).
;; 122
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 123
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 124
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 125
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 126
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 127
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 128
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 129
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 130
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 131
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 132
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 133
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 134
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 135
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 136
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 137
%chima:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 138
%chima:2, cross_gen[aux]102:0, parents:0, sibling:0, parents:0, parents:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, H), mother(H, Alter), male(Alter).
;; 139
%chima:2, cross_gen[aux]102:0, parents:0, sibling:0, parents:0, parents:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, H), father(H, Alter), male(Alter).
;; 140
%chima:2, cross_gen[aux]102:0, parents:0, sibling:0, parents:1, parents:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, H), mother(H, Alter), male(Alter).
;; 141
%chima:2, cross_gen[aux]102:0, parents:0, sibling:0, parents:1, parents:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, H), father(H, Alter), male(Alter).
;; 142
%chima:2, cross_gen[aux]102:0, parents:1, sibling:0, parents:0, parents:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, H), mother(H, Alter), male(Alter).
;; 143
%chima:2, cross_gen[aux]102:0, parents:1, sibling:0, parents:0, parents:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, H), father(H, Alter), male(Alter).
;; 144
%chima:2, cross_gen[aux]102:0, parents:1, sibling:0, parents:1, parents:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, H), mother(H, Alter), male(Alter).
;; 145
%chima:2, cross_gen[aux]102:0, parents:1, sibling:0, parents:1, parents:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, H), father(H, Alter), male(Alter).
;; 146
%chima:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 147
%chima:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 148
%chima:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 149
%chima:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 150
%chima:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 151
%chima:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 152
%chima:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 153
%chima:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 154
%chima:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 155
%chima:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 156
%chima:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 157
%chima:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 158
%chima:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 159
%chima:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 160
%chima:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 161
%chima:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 162
%chima:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 163
%chima:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 164
%chima:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 165
%chima:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 166
%chima:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 167
%chima:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 168
%chima:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 169
%chima:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 170
%chima:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 171
%chima:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 172
%chima:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 173
%chima:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 174
%chima:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 175
%chima:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 176
%chima:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 177
%chima:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 178
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 179
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 180
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 181
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 182
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 183
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 184
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 185
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 186
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 187
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 188
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 189
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 190
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 191
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 192
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 193
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 194
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 195
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 196
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 197
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).
;; 198
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 199
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 200
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 201
%chima:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).
;; 202
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 203
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 204
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 205
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 206
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 207
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 208
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 209
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 210
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 211
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 212
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 213
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 214
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 215
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 216
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 217
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 218
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 219
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 220
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 221
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).
;; 222
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 223
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 224
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 225
%chima:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).
;; 226
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 227
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 228
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 229
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 230
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 231
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 232
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 233
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 234
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 235
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 236
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 237
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 238
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 239
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 240
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 241
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 242
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 243
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 244
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 245
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).
;; 246
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 247
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 248
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 249
%chima:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).
;; 250
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 251
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 252
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 253
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 254
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 255
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 256
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 257
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 258
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 259
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 260
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 261
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 262
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 263
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 264
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 265
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 266
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 267
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 268
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 269
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).
;; 270
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 271
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 272
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 273
%chima:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).


cross_cousin[aux]10(Alter, Ego) :-  parents(A, Ego), cross_gen[aux]102(B, A), child(Alter, B).
;; 0
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:0, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), child(Alter, H).
;; 1
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:0, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), child(Alter, H).
;; 2
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 3
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 4
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 5
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 6
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 7
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 8
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 9
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 10
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 11
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 12
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), mother(B, A), father(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 13
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), mother(B, A), father(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 14
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 15
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 16
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 17
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 18
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 19
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 20
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 21
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 22
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 23
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 24
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), father(B, A), father(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 25
%cross_cousin[aux]10:0, parents:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), father(B, A), father(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 26
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:0, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), child(Alter, H).
;; 27
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:0, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), child(Alter, H).
;; 28
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 29
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 30
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 31
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 32
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 33
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 34
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 35
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 36
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 37
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 38
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), mother(B, A), father(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 39
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), mother(B, A), father(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 40
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 41
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 42
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 43
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 44
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 45
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 46
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 47
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 48
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 49
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(M, L), gender(N, B), gender(O, L), not(equal(N, O)), child(Alter, M).
;; 50
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), father(B, A), father(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).
;; 51
%cross_cousin[aux]10:0, parents:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), father(B, A), father(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(J, I), gender(K, B), gender(L, I), not(equal(K, L)), child(Alter, J).


cross_gen[aux]10(Alter, Ego) :-  sibling(Alter, Ego), gender(A, Ego), gender(B, Alter), not(equal(A, B)).
                             |   cross_gen[aux]102(Alter, Ego).
;; 0
%cross_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 male(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Ego), gender(D, Alter), not(equal(C, D)).
;; 1
%cross_gen[aux]10:1, cross_gen[aux]102:0, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C).
;; 2
%cross_gen[aux]10:1, cross_gen[aux]102:0, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C).
;; 3
%cross_gen[aux]10:1, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H).
;; 4
%cross_gen[aux]10:1, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H).
;; 5
%cross_gen[aux]10:1, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H).
;; 6
%cross_gen[aux]10:1, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H).
;; 7
%cross_gen[aux]10:1, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H).
;; 8
%cross_gen[aux]10:1, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H).
;; 9
%cross_gen[aux]10:1, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H).
;; 10
%cross_gen[aux]10:1, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H).
;; 11
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)).
;; 12
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 13
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 14
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 15
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 16
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 17
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 18
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 19
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 20
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)).
;; 21
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 22
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 23
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 24
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 25
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 26
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 27
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 28
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 29
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)).
;; 30
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 31
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 32
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 33
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 34
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 35
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 36
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 37
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 38
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)).
;; 39
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 40
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 41
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 42
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 43
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 44
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 45
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 46
%cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 47
%cross_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 female(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Ego), gender(D, Alter), not(equal(C, D)).


cross_gen[aux]102(Alter, Ego) :- [ext],  parents(A, Ego), sibling(A, B), gender(C, B), gender(D, A), not(equal(C, D)), child(Alter, B).
                              |  [ext],  parents(A, Ego), parents(B, A), sibling(B, C), gender(D, C), gender(E, B), not(equal(D, E)), children(F, C), child(Alter, F).
                              |  [ext],  parents(A, Ego), parents(B, A), parallel_gen[aux]10(B, C), child(D, C), child(Alter, D), gender(E, A), gender(F, D), not(equal(E, F)).
;; 0
%cross_gen[aux]102:0, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C).
;; 1
%cross_gen[aux]102:0, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C).
;; 2
%cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H).
;; 3
%cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H).
;; 4
%cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H).
;; 5
%cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H).
;; 6
%cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H).
;; 7
%cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H).
;; 8
%cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H).
;; 9
%cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H).
;; 10
%cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)).
;; 11
%cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 12
%cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 13
%cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 14
%cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 15
%cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 16
%cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 17
%cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 18
%cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 19
%cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)).
;; 20
%cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 21
%cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 22
%cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 23
%cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 24
%cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 25
%cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 26
%cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 27
%cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 28
%cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)).
;; 29
%cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 30
%cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 31
%cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 32
%cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 33
%cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 34
%cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 35
%cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 36
%cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 37
%cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)).
;; 38
%cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 39
%cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 40
%cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 41
%cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)).
;; 42
%cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 43
%cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)).
;; 44
%cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).
;; 45
%cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)).


elder_para_gen[aux]10(Alter, Ego) :-  sibling(Alter, Ego), gender(A, Alter), gender(A, Ego), elder(Alter, Ego).
                                  |   parents(A, Ego), elder_para_gen[aux]10(B, A), child(Alter, B), gender(C, A), gender(C, B).
                                  |  [ext],  step_child[aux]10(Ego, A), child(Alter, A), gender(B, Alter), gender(B, Ego), elder(Alter, Ego).
                                  |  [ext],  step_child[aux]10(Ego, A), elder_para_gen[aux]10(B, A), child(Alter, B), gender(C, A), gender(C, B).
;; 0
%elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 male(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Alter), gender(C, Ego), elder(Alter, Ego).
;; 1
%elder_para_gen[aux]10:1, parents:0, elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), elder(D, A), child(Alter, D), gender(F, A), gender(F, D).
;; 2
%elder_para_gen[aux]10:1, parents:0, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), elder(E, A), child(Alter, E), gender(G, A), gender(G, E).
;; 3
%elder_para_gen[aux]10:1, parents:0, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), elder(E, A), child(Alter, E), gender(G, A), gender(G, E).
;; 4
%elder_para_gen[aux]10:1, parents:1, elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), elder(D, A), child(Alter, D), gender(F, A), gender(F, D).
;; 5
%elder_para_gen[aux]10:1, parents:1, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), elder(E, A), child(Alter, E), gender(G, A), gender(G, E).
;; 6
%elder_para_gen[aux]10:1, parents:1, elder_para_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), elder(E, A), child(Alter, E), gender(G, A), gender(G, E).
;; 7
%elder_para_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(Alter, B), gender(D, Alter), gender(D, Ego), elder(Alter, Ego).
;; 8
%elder_para_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(Alter, B), gender(D, Alter), gender(D, Ego), elder(Alter, Ego).
;; 9
%elder_para_gen[aux]10:3, step_child[aux]10:0, spice:0, elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), elder(F, B), child(Alter, F), gender(H, B), gender(H, F).
;; 10
%elder_para_gen[aux]10:3, step_child[aux]10:0, spice:1, elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), elder(F, B), child(Alter, F), gender(H, B), gender(H, F).
;; 11
%elder_para_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 female(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Alter), gender(C, Ego), elder(Alter, Ego).
;; 12
%elder_para_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(Alter, B), gender(D, Alter), gender(D, Ego), elder(Alter, Ego).
;; 13
%elder_para_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(Alter, B), gender(D, Alter), gender(D, Ego), elder(Alter, Ego).


generation[aux]10(Alter, Ego) :-  sibling(Alter, Ego).
                              |   parents(A, Ego), generation[aux]10gs(B, A), child(Alter, B).
;; 0
%generation[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).
;; 1
%generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 2
%generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 3
%generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 4
%generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 5
%generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 6
%generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 7
%generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 8
%generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 9
%generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 10
%generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 11
%generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 12
%generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 13
%generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 14
%generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 15
%generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 16
%generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 17
%generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 18
%generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 19
%generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 20
%generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).


generation[aux]10gs(Alter, Ego) :-  siblings(Alter, Ego).
                                |   parents(A, Ego), generation[aux]10gs(B, A), children(Alter, B).
;; 0
%generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter).
;; 1
%generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter).
;; 2
%generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 3
%generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 4
%generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 5
%generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).
;; 6
%generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 7
%generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 8
%generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 9
%generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).


generation[aux]10small(Alter, Ego) :-  sibling(Alter, Ego).
                                   |   parents(A, Ego), siblings(B, A), child(Alter, B).
;; 0
%generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).
;; 1
%generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 2
%generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 3
%generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 4
%generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).


grandparent[aux]10(Alter, Ego) :-  grandparent[aux]10direct(Alter, Ego).
                               |   spouse(A, Ego), grandparent[aux]10direct(Alter, A).
;; 0
%grandparent[aux]10:0, grandparent[aux]10direct:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), parent(Alter, A).
;; 1
%grandparent[aux]10:0, grandparent[aux]10direct:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), parent(Alter, A).
;; 2
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 3
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 4
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 5
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 6
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 7
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), parent(Alter, B).
;; 8
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 9
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 10
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 11
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 12
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 13
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), parent(Alter, C).
;; 14
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 15
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 16
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 17
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 18
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 19
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), parent(Alter, C).
;; 20
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 21
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 22
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 23
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 24
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 25
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), parent(Alter, B).
;; 26
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 27
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 28
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 29
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 30
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 31
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), parent(Alter, C).
;; 32
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 33
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 34
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 35
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 36
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 37
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), parent(Alter, C).
;; 38
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 39
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 40
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 41
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 42
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 43
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), parent(Alter, B).
;; 44
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 45
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 46
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 47
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 48
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 49
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), parent(Alter, C).
;; 50
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 51
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 52
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 53
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 54
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 55
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), parent(Alter, C).
;; 56
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 57
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 58
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 59
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 60
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 61
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), parent(Alter, B).
;; 62
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 63
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 64
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 65
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 66
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 67
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), parent(Alter, C).
;; 68
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 69
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 70
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 71
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 72
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 73
%grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), parent(Alter, C).
;; 74
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 75
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 76
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 77
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 78
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 79
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), parent(C, B), spouse(Alter, C).
;; 80
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 81
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 82
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 83
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 84
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 85
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 86
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 87
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 88
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 89
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 90
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 91
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 92
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 93
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 94
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 95
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 96
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 97
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), parent(C, B), spouse(Alter, C).
;; 98
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 99
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 100
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 101
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 102
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 103
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 104
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 105
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 106
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 107
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 108
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 109
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 110
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 111
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 112
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 113
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 114
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 115
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), parent(C, B), spouse(Alter, C).
;; 116
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 117
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 118
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 119
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 120
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 121
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 122
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 123
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 124
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 125
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 126
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 127
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 128
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 129
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 130
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 131
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 132
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 133
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), parent(C, B), spouse(Alter, C).
;; 134
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 135
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 136
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 137
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 138
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 139
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 140
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 141
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 142
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 143
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 144
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 145
%grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 146
%grandparent[aux]10:1, grandparent[aux]10direct:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 spouse(A, Ego), mother(B, A), parent(Alter, B).
;; 147
%grandparent[aux]10:1, grandparent[aux]10direct:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 spouse(A, Ego), father(B, A), parent(Alter, B).
;; 148
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 149
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 150
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 151
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 152
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 153
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), parent(Alter, C).
;; 154
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 155
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, C), parent(Alter, D).
;; 156
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 157
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, C), parent(Alter, D).
;; 158
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 159
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 160
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 161
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 162
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 163
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), parent(Alter, C).
;; 164
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 165
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, C), parent(Alter, D).
;; 166
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 167
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), father(D, C), parent(Alter, D).
;; 168
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 169
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 170
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 171
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 172
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 173
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), parent(Alter, C).
;; 174
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 175
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, C), parent(Alter, D).
;; 176
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 177
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, C), parent(Alter, D).
;; 178
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 179
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 180
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 181
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 182
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 183
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), parent(Alter, C).
;; 184
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 185
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, C), parent(Alter, D).
;; 186
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 187
%grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), father(D, C), parent(Alter, D).
;; 188
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 189
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 190
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 191
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 192
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 193
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 194
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 195
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Alter, E).
;; 196
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 197
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Alter, E).
;; 198
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 199
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 200
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 201
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 202
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 203
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 204
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 205
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Alter, E).
;; 206
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 207
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), father(D, C), parent(E, D), spouse(Alter, E).
;; 208
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 209
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 210
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 211
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 212
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 213
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 214
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 215
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Alter, E).
;; 216
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 217
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Alter, E).
;; 218
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 219
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 220
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 221
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 222
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 223
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 224
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 225
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Alter, E).
;; 226
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 227
%grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), father(D, C), parent(E, D), spouse(Alter, E).


grandparent[aux]10direct(Alter, Ego) :-  parents(A, Ego), parent(Alter, A).
                                     |  [ext],  parents(A, Ego), parents(B, A), square[aux]10up_small(Alter, B).
                                     |  [ext],  parents(A, Ego), parents(B, A), square[aux]10up_small(C, B), spouse(Alter, C).
;; 0
%grandparent[aux]10direct:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), parent(Alter, A).
;; 1
%grandparent[aux]10direct:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), parent(Alter, A).
;; 2
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 3
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 4
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 5
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 6
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 7
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), parent(Alter, B).
;; 8
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 9
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 10
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 11
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 12
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 13
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), parent(Alter, C).
;; 14
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 15
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 16
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 17
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 18
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 19
%grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), parent(Alter, C).
;; 20
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 21
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 22
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 23
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 24
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 25
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), parent(Alter, B).
;; 26
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 27
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 28
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 29
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 30
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 31
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), parent(Alter, C).
;; 32
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 33
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 34
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 35
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 36
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 37
%grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), parent(Alter, C).
;; 38
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 39
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 40
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 41
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 42
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 43
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), parent(Alter, B).
;; 44
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 45
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 46
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 47
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 48
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 49
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), parent(Alter, C).
;; 50
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 51
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 52
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 53
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 54
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 55
%grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), parent(Alter, C).
;; 56
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 57
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 58
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 59
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 60
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 61
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), parent(Alter, B).
;; 62
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 63
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 64
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 65
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 66
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 67
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), parent(Alter, C).
;; 68
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 69
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 70
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 71
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 72
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 73
%grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), parent(Alter, C).
;; 74
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 75
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 76
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 77
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 78
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 79
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), parent(C, B), spouse(Alter, C).
;; 80
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 81
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 82
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 83
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 84
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 85
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 86
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 87
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 88
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 89
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 90
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 91
%grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 92
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 93
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 94
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 95
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 96
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 97
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), parent(C, B), spouse(Alter, C).
;; 98
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 99
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 100
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 101
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 102
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 103
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 104
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 105
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 106
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 107
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 108
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 109
%grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 110
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 111
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 112
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 113
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 114
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 115
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), parent(C, B), spouse(Alter, C).
;; 116
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 117
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 118
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 119
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 120
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 121
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 122
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 123
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 124
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 125
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 126
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 127
%grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 128
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 129
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 130
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 131
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 132
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 133
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), parent(C, B), spouse(Alter, C).
;; 134
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 135
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 136
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 137
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 138
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 139
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 140
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 141
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 142
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 143
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 144
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 145
%grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D).


grandparent[aux]10es(Alter, Ego) :-  grandparent[aux]10direct(Alter, Ego).
                                 |   spice(A, Ego), grandparent[aux]10direct(Alter, A).
;; 0
%grandparent[aux]10es:0, grandparent[aux]10direct:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), parent(Alter, A).
;; 1
%grandparent[aux]10es:0, grandparent[aux]10direct:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), parent(Alter, A).
;; 2
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 3
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 4
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 5
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 6
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 7
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), parent(Alter, B).
;; 8
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 9
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 10
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 11
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 12
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 13
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), parent(Alter, C).
;; 14
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 15
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 16
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 17
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 18
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 19
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), parent(Alter, C).
;; 20
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 21
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 22
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 23
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 24
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 25
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), parent(Alter, B).
;; 26
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 27
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 28
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 29
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 30
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 31
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), parent(Alter, C).
;; 32
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 33
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 34
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 35
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 36
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 37
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), parent(Alter, C).
;; 38
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 39
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 40
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 41
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 42
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 43
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), parent(Alter, B).
;; 44
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 45
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 46
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 47
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 48
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 49
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), parent(Alter, C).
;; 50
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 51
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 52
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 53
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 54
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 55
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), parent(Alter, C).
;; 56
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 57
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 58
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 59
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 60
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 61
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), parent(Alter, B).
;; 62
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 63
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 64
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 65
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 66
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 67
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), parent(Alter, C).
;; 68
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 69
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 70
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 71
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 72
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 73
%grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), parent(Alter, C).
;; 74
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 75
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 76
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 77
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 78
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 79
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), parent(C, B), spouse(Alter, C).
;; 80
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 81
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 82
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 83
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 84
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 85
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 86
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 87
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 88
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 89
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 90
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 91
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 92
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 93
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 94
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 95
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 96
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 97
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), parent(C, B), spouse(Alter, C).
;; 98
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 99
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 100
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 101
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 102
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 103
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 104
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 105
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 106
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 107
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 108
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 109
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 110
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 111
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 112
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 113
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 114
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 115
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), parent(C, B), spouse(Alter, C).
;; 116
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 117
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 118
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 119
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 120
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 121
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 122
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 123
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 124
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 125
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 126
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 127
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 128
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 129
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 130
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 131
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 132
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 133
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), parent(C, B), spouse(Alter, C).
;; 134
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 135
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 136
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 137
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 138
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 139
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 140
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 141
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 142
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 143
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 144
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 145
%grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 146
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(A, Ego), mother(B, A), parent(Alter, B).
;; 147
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(A, Ego), father(B, A), parent(Alter, B).
;; 148
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 149
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 150
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 151
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 152
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 153
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), parent(Alter, C).
;; 154
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 155
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), parent(Alter, D).
;; 156
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 157
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), parent(Alter, D).
;; 158
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 159
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 160
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 161
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 162
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 163
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), parent(Alter, C).
;; 164
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 165
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), parent(Alter, D).
;; 166
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 167
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), parent(Alter, D).
;; 168
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 169
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 170
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 171
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 172
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 173
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), parent(Alter, C).
;; 174
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 175
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), parent(Alter, D).
;; 176
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 177
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), parent(Alter, D).
;; 178
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 179
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 180
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 181
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 182
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 183
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), parent(Alter, C).
;; 184
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 185
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), parent(Alter, D).
;; 186
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 187
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), parent(Alter, D).
;; 188
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 189
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 190
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 191
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 192
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 193
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 194
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 195
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Alter, E).
;; 196
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 197
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Alter, E).
;; 198
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 199
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 200
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 201
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 202
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 203
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 204
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 205
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Alter, E).
;; 206
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 207
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), parent(E, D), spouse(Alter, E).
;; 208
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 209
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 210
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 211
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 212
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 213
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 214
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 215
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Alter, E).
;; 216
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 217
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Alter, E).
;; 218
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 219
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 220
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 221
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 222
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 223
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 224
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 225
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Alter, E).
;; 226
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 227
%grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), parent(E, D), spouse(Alter, E).
;; 228
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 wife(A, Ego), mother(B, A), parent(Alter, B).
;; 229
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 wife(A, Ego), father(B, A), parent(Alter, B).
;; 230
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 231
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 232
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 233
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 234
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 235
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), parent(Alter, C).
;; 236
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 237
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), parent(Alter, D).
;; 238
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 239
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), parent(Alter, D).
;; 240
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 241
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 242
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 243
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 244
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 245
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), parent(Alter, C).
;; 246
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 247
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), parent(Alter, D).
;; 248
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 249
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), parent(Alter, D).
;; 250
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 251
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 252
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 253
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 254
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 255
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), parent(Alter, C).
;; 256
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 257
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), parent(Alter, D).
;; 258
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 259
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), parent(Alter, D).
;; 260
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 261
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 262
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 263
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 264
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 265
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), parent(Alter, C).
;; 266
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 267
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), parent(Alter, D).
;; 268
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)).
;; 269
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), parent(Alter, D).
;; 270
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 271
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 272
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 273
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 274
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 275
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 276
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 277
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Alter, E).
;; 278
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 279
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Alter, E).
;; 280
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 281
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 282
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 283
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 284
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 285
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 286
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 287
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Alter, E).
;; 288
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 289
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), parent(E, D), spouse(Alter, E).
;; 290
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 291
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 292
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 293
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 294
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 295
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D).
;; 296
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 297
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Alter, E).
;; 298
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 299
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Alter, E).
;; 300
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F).
;; 301
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 302
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 303
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(H, G), spouse(Alter, H).
;; 304
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(H, G), spouse(Alter, H).
;; 305
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D).
;; 306
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 307
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Alter, E).
;; 308
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G).
;; 309
%grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), parent(E, D), spouse(Alter, E).


half_brother(Alter, Ego) :-  mother(A, Ego), father(B, Ego), wife(C, B), son(Alter, C), son(Alter, B), not(equal(C, A)).
                         |   mother(A, Ego), father(B, Ego), husband(C, A), son(Alter, C), son(Alter, A), not(equal(C, B)).
;; 0
%half_brother:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), wife(C, B), son(Alter, C), son(Alter, B), not(equal(C, A)).
;; 1
%half_brother:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), husband(C, A), son(Alter, C), son(Alter, A), not(equal(C, B)).


half_sister(Alter, Ego) :-  mother(A, Ego), father(B, Ego), wife(C, B), daughter(Alter, C), daughter(Alter, B), not(equal(C, A)).
                        |   mother(A, Ego), father(B, Ego), husband(C, A), daughter(Alter, C), daughter(Alter, A), not(equal(C, B)).
;; 0
%half_sister:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), wife(C, B), daughter(Alter, C), daughter(Alter, B), not(equal(C, A)).
;; 1
%half_sister:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), husband(C, A), daughter(Alter, C), daughter(Alter, A), not(equal(C, B)).


jibuwaimo(Alter, Ego) :-  step_daughter(Alter, Ego).
{"**"}
;; 0
%jibuwaimo:0, step_daughter:0%
 Lvl=-1,  PC=2, S=2, Star=0,  {**}  
 spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(Alter, B), daughter(Alter, A).


jibuwaimu(Alter, Ego) :-  step_son(Alter, Ego).
{"**"}
;; 0
%jibuwaimu:0, step_son:0%
 Lvl=-1,  PC=2, S=2, Star=0,  {**}  
 spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(Alter, B), son(Alter, A).


jicapenumo(Alter, Ego) :-  wife(A, Ego), parallel_gen[aux]10(Alter, A).
                       |  [ext],  male(Ego), parallel_gen[aux]10(A, Ego), wife(Alter, A).
{"**"}
;; 0
%jicapenumo:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), gender(D, Alter), gender(D, A).
;; 1
%jicapenumo:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(Alter, E), gender(G, Alter), gender(G, A).
;; 2
%jicapenumo:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext],  wife(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(Alter, F), gender(H, Alter), gender(H, A).
;; 3
%jicapenumo:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext],  wife(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(Alter, F), gender(H, Alter), gender(H, A).
;; 4
%jicapenumo:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(Alter, E), gender(G, Alter), gender(G, A).
;; 5
%jicapenumo:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext],  wife(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(Alter, F), gender(H, Alter), gender(H, A).
;; 6
%jicapenumo:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext],  wife(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(Alter, F), gender(H, Alter), gender(H, A).
;; 7
%jicapenumo:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=3, S=3, Star=0,  {**}  
[ext],  wife(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(Alter, C), gender(E, Alter), gender(E, A).
;; 8
%jicapenumo:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=3, S=3, Star=0,  {**}  
[ext],  wife(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(Alter, C), gender(E, Alter), gender(E, A).
;; 9
%jicapenumo:0, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=3, Star=0,  {**}  
[ext],  wife(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(Alter, G), gender(I, Alter), gender(I, A).
;; 10
%jicapenumo:0, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=3, Star=0,  {**}  
[ext],  wife(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(Alter, G), gender(I, Alter), gender(I, A).
;; 11
%jicapenumo:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {**}  
[ext],  male(Ego), mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), gender(D, C), gender(D, Ego), wife(Alter, C).
;; 12
%jicapenumo:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {**}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), child(F, D), gender(G, F), gender(G, Ego), wife(Alter, F).
;; 13
%jicapenumo:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(G, E), gender(H, G), gender(H, Ego), wife(Alter, G).
;; 14
%jicapenumo:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(G, E), gender(H, G), gender(H, Ego), wife(Alter, G).
;; 15
%jicapenumo:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {**}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), child(F, D), gender(G, F), gender(G, Ego), wife(Alter, F).
;; 16
%jicapenumo:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(G, E), gender(H, G), gender(H, Ego), wife(Alter, G).
;; 17
%jicapenumo:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext], [ext],  male(Ego), father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(G, E), gender(H, G), gender(H, Ego), wife(Alter, G).
;; 18
%jicapenumo:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=3, S=3, Star=0,  {**}  
[ext], [ext],  male(Ego), husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(D, B), gender(E, D), gender(E, Ego), wife(Alter, D).
;; 19
%jicapenumo:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=3, S=3, Star=0,  {**}  
[ext], [ext],  male(Ego), wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(D, B), gender(E, D), gender(E, Ego), wife(Alter, D).
;; 20
%jicapenumo:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=3, Star=0,  {**}  
[ext], [ext],  male(Ego), husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, Ego), wife(Alter, H).
;; 21
%jicapenumo:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=3, Star=0,  {**}  
[ext], [ext],  male(Ego), wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, Ego), wife(Alter, H).


jicapenumu(Alter, Ego) :-  husband(A, Ego), parallel_gen[aux]10(Alter, A).
                       |  [ext],  female(Ego), parallel_gen[aux]10(A, Ego), husband(Alter, A).
{"**"}
;; 0
%jicapenumu:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), gender(D, Alter), gender(D, A).
;; 1
%jicapenumu:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(Alter, E), gender(G, Alter), gender(G, A).
;; 2
%jicapenumu:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext],  husband(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(Alter, F), gender(H, Alter), gender(H, A).
;; 3
%jicapenumu:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext],  husband(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(Alter, F), gender(H, Alter), gender(H, A).
;; 4
%jicapenumu:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(Alter, E), gender(G, Alter), gender(G, A).
;; 5
%jicapenumu:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext],  husband(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(Alter, F), gender(H, Alter), gender(H, A).
;; 6
%jicapenumu:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext],  husband(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(Alter, F), gender(H, Alter), gender(H, A).
;; 7
%jicapenumu:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=3, S=3, Star=0,  {**}  
[ext],  husband(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(Alter, C), gender(E, Alter), gender(E, A).
;; 8
%jicapenumu:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=3, S=3, Star=0,  {**}  
[ext],  husband(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(Alter, C), gender(E, Alter), gender(E, A).
;; 9
%jicapenumu:0, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=3, Star=0,  {**}  
[ext],  husband(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(Alter, G), gender(I, Alter), gender(I, A).
;; 10
%jicapenumu:0, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=3, Star=0,  {**}  
[ext],  husband(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(Alter, G), gender(I, Alter), gender(I, A).
;; 11
%jicapenumu:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), gender(D, C), gender(D, Ego), husband(Alter, C).
;; 12
%jicapenumu:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), child(F, D), gender(G, F), gender(G, Ego), husband(Alter, F).
;; 13
%jicapenumu:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(G, E), gender(H, G), gender(H, Ego), husband(Alter, G).
;; 14
%jicapenumu:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(G, E), gender(H, G), gender(H, Ego), husband(Alter, G).
;; 15
%jicapenumu:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), child(F, D), gender(G, F), gender(G, Ego), husband(Alter, F).
;; 16
%jicapenumu:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(G, E), gender(H, G), gender(H, Ego), husband(Alter, G).
;; 17
%jicapenumu:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=3, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(G, E), gender(H, G), gender(H, Ego), husband(Alter, G).
;; 18
%jicapenumu:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=3, S=3, Star=0,  {**}  
[ext], [ext],  female(Ego), husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(D, B), gender(E, D), gender(E, Ego), husband(Alter, D).
;; 19
%jicapenumu:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=3, S=3, Star=0,  {**}  
[ext], [ext],  female(Ego), wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(D, B), gender(E, D), gender(E, Ego), husband(Alter, D).
;; 20
%jicapenumu:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=3, Star=0,  {**}  
[ext], [ext],  female(Ego), husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, Ego), husband(Alter, H).
;; 21
%jicapenumu:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=3, Star=0,  {**}  
[ext], [ext],  female(Ego), wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, Ego), husband(Alter, H).


jichimaco(Alter, Ego) :-  cross_gen[aux]102(Alter, Ego), female(Alter).
                      |   cross_gen[aux]102(A, Ego), parents(A, Alter), female(Alter).
                      |   cross_gen[aux]102(A, Ego), parents(A, B), parents(B, Alter), female(Alter).
{"**"}
;; 0
%jichimaco:0, cross_gen[aux]102:0, parents:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C), female(Alter).
;; 1
%jichimaco:0, cross_gen[aux]102:0, parents:1, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C), female(Alter).
;; 2
%jichimaco:0, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H), female(Alter).
;; 3
%jichimaco:0, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H), female(Alter).
;; 4
%jichimaco:0, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H), female(Alter).
;; 5
%jichimaco:0, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H), female(Alter).
;; 6
%jichimaco:0, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H), female(Alter).
;; 7
%jichimaco:0, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H), female(Alter).
;; 8
%jichimaco:0, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H), female(Alter).
;; 9
%jichimaco:0, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H), female(Alter).
;; 10
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)), female(Alter).
;; 11
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), female(Alter).
;; 12
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 13
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 14
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), female(Alter).
;; 15
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 16
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 17
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), female(Alter).
;; 18
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), female(Alter).
;; 19
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)), female(Alter).
;; 20
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), female(Alter).
;; 21
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 22
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 23
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), female(Alter).
;; 24
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 25
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 26
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), female(Alter).
;; 27
%jichimaco:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), female(Alter).
;; 28
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)), female(Alter).
;; 29
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), female(Alter).
;; 30
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 31
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 32
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), female(Alter).
;; 33
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 34
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 35
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), female(Alter).
;; 36
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), female(Alter).
;; 37
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)), female(Alter).
;; 38
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), female(Alter).
;; 39
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 40
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 41
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), female(Alter).
;; 42
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 43
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), female(Alter).
;; 44
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), female(Alter).
;; 45
%jichimaco:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), female(Alter).
;; 46
%jichimaco:1, cross_gen[aux]102:0, parents:0, sibling:0, parents:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, Alter), female(Alter).
;; 47
%jichimaco:1, cross_gen[aux]102:0, parents:0, sibling:0, parents:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, Alter), female(Alter).
;; 48
%jichimaco:1, cross_gen[aux]102:0, parents:1, sibling:0, parents:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, Alter), female(Alter).
;; 49
%jichimaco:1, cross_gen[aux]102:0, parents:1, sibling:0, parents:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, Alter), female(Alter).
;; 50
%jichimaco:1, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, Alter), female(Alter).
;; 51
%jichimaco:1, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, Alter), female(Alter).
;; 52
%jichimaco:1, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, Alter), female(Alter).
;; 53
%jichimaco:1, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, Alter), female(Alter).
;; 54
%jichimaco:1, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, Alter), female(Alter).
;; 55
%jichimaco:1, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, Alter), female(Alter).
;; 56
%jichimaco:1, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, Alter), female(Alter).
;; 57
%jichimaco:1, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, Alter), female(Alter).
;; 58
%jichimaco:1, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, Alter), female(Alter).
;; 59
%jichimaco:1, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, Alter), female(Alter).
;; 60
%jichimaco:1, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, Alter), female(Alter).
;; 61
%jichimaco:1, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, Alter), female(Alter).
;; 62
%jichimaco:1, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, Alter), female(Alter).
;; 63
%jichimaco:1, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, Alter), female(Alter).
;; 64
%jichimaco:1, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, Alter), female(Alter).
;; 65
%jichimaco:1, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, Alter), female(Alter).
;; 66
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), mother(H, Alter), female(Alter).
;; 67
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), father(H, Alter), female(Alter).
;; 68
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), female(Alter).
;; 69
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), female(Alter).
;; 70
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 71
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 72
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 73
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 74
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), female(Alter).
;; 75
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), female(Alter).
;; 76
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 77
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 78
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 79
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 80
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), female(Alter).
;; 81
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), female(Alter).
;; 82
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), female(Alter).
;; 83
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), female(Alter).
;; 84
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), mother(H, Alter), female(Alter).
;; 85
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), father(H, Alter), female(Alter).
;; 86
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), female(Alter).
;; 87
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), female(Alter).
;; 88
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 89
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 90
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 91
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 92
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), female(Alter).
;; 93
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), female(Alter).
;; 94
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 95
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 96
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 97
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 98
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), female(Alter).
;; 99
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), female(Alter).
;; 100
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), female(Alter).
;; 101
%jichimaco:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), female(Alter).
;; 102
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), mother(H, Alter), female(Alter).
;; 103
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), father(H, Alter), female(Alter).
;; 104
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), female(Alter).
;; 105
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), female(Alter).
;; 106
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 107
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 108
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 109
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 110
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), female(Alter).
;; 111
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), female(Alter).
;; 112
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 113
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 114
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 115
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 116
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), female(Alter).
;; 117
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), female(Alter).
;; 118
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), female(Alter).
;; 119
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), female(Alter).
;; 120
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), mother(H, Alter), female(Alter).
;; 121
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), father(H, Alter), female(Alter).
;; 122
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), female(Alter).
;; 123
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), female(Alter).
;; 124
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 125
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 126
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 127
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 128
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), female(Alter).
;; 129
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), female(Alter).
;; 130
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 131
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 132
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), female(Alter).
;; 133
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), female(Alter).
;; 134
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), female(Alter).
;; 135
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), female(Alter).
;; 136
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), female(Alter).
;; 137
%jichimaco:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), female(Alter).
;; 138
%jichimaco:2, cross_gen[aux]102:0, parents:0, sibling:0, parents:0, parents:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, H), mother(H, Alter), female(Alter).
;; 139
%jichimaco:2, cross_gen[aux]102:0, parents:0, sibling:0, parents:0, parents:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, H), father(H, Alter), female(Alter).
;; 140
%jichimaco:2, cross_gen[aux]102:0, parents:0, sibling:0, parents:1, parents:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, H), mother(H, Alter), female(Alter).
;; 141
%jichimaco:2, cross_gen[aux]102:0, parents:0, sibling:0, parents:1, parents:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, H), father(H, Alter), female(Alter).
;; 142
%jichimaco:2, cross_gen[aux]102:0, parents:1, sibling:0, parents:0, parents:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, H), mother(H, Alter), female(Alter).
;; 143
%jichimaco:2, cross_gen[aux]102:0, parents:1, sibling:0, parents:0, parents:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, H), father(H, Alter), female(Alter).
;; 144
%jichimaco:2, cross_gen[aux]102:0, parents:1, sibling:0, parents:1, parents:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, H), mother(H, Alter), female(Alter).
;; 145
%jichimaco:2, cross_gen[aux]102:0, parents:1, sibling:0, parents:1, parents:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, H), father(H, Alter), female(Alter).
;; 146
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), mother(J, Alter), female(Alter).
;; 147
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), father(J, Alter), female(Alter).
;; 148
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), mother(J, Alter), female(Alter).
;; 149
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), father(J, Alter), female(Alter).
;; 150
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), mother(J, Alter), female(Alter).
;; 151
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), father(J, Alter), female(Alter).
;; 152
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), mother(J, Alter), female(Alter).
;; 153
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), father(J, Alter), female(Alter).
;; 154
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), mother(J, Alter), female(Alter).
;; 155
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), father(J, Alter), female(Alter).
;; 156
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), mother(J, Alter), female(Alter).
;; 157
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), father(J, Alter), female(Alter).
;; 158
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), mother(J, Alter), female(Alter).
;; 159
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), father(J, Alter), female(Alter).
;; 160
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), mother(J, Alter), female(Alter).
;; 161
%jichimaco:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), father(J, Alter), female(Alter).
;; 162
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), mother(J, Alter), female(Alter).
;; 163
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), father(J, Alter), female(Alter).
;; 164
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), mother(J, Alter), female(Alter).
;; 165
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), father(J, Alter), female(Alter).
;; 166
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), mother(J, Alter), female(Alter).
;; 167
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), father(J, Alter), female(Alter).
;; 168
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), mother(J, Alter), female(Alter).
;; 169
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), father(J, Alter), female(Alter).
;; 170
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), mother(J, Alter), female(Alter).
;; 171
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), father(J, Alter), female(Alter).
;; 172
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), mother(J, Alter), female(Alter).
;; 173
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), father(J, Alter), female(Alter).
;; 174
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), mother(J, Alter), female(Alter).
;; 175
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), father(J, Alter), female(Alter).
;; 176
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), mother(J, Alter), female(Alter).
;; 177
%jichimaco:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), father(J, Alter), female(Alter).


jichimacu(Alter, Ego) :-  female(Ego), cross_gen[aux]102(Alter, Ego), male(Alter).
                      |   female(Ego), cross_gen[aux]102(A, Ego), parents(A, Alter), male(Alter).
                      |   female(Ego), cross_gen[aux]102(A, Ego), parents(A, B), parents(B, Alter), male(Alter).
{"**"}
;; 0
%jichimacu:0, cross_gen[aux]102:0, parents:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C), male(Alter).
;; 1
%jichimacu:0, cross_gen[aux]102:0, parents:1, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C), male(Alter).
;; 2
%jichimacu:0, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H), male(Alter).
;; 3
%jichimacu:0, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H), male(Alter).
;; 4
%jichimacu:0, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H), male(Alter).
;; 5
%jichimacu:0, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H), male(Alter).
;; 6
%jichimacu:0, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H), male(Alter).
;; 7
%jichimacu:0, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H), male(Alter).
;; 8
%jichimacu:0, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(Alter, H), male(Alter).
;; 9
%jichimacu:0, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(Alter, H), male(Alter).
;; 10
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)), male(Alter).
;; 11
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 12
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 13
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 14
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 15
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 16
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 17
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 18
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 19
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)), male(Alter).
;; 20
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 21
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 22
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 23
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 24
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 25
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 26
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 27
%jichimacu:0, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 28
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)), male(Alter).
;; 29
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 30
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 31
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 32
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 33
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 34
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 35
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 36
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 37
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(Alter, G), gender(H, A), gender(I, G), not(equal(H, I)), male(Alter).
;; 38
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 39
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 40
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 41
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=10, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(Alter, J), gender(K, A), gender(L, J), not(equal(K, L)), male(Alter).
;; 42
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 43
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=9, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(Alter, K), gender(L, A), gender(M, K), not(equal(L, M)), male(Alter).
;; 44
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 45
%jichimacu:0, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(Alter, H), gender(I, A), gender(J, H), not(equal(I, J)), male(Alter).
;; 46
%jichimacu:1, cross_gen[aux]102:0, parents:0, sibling:0, parents:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, Alter), male(Alter).
;; 47
%jichimacu:1, cross_gen[aux]102:0, parents:0, sibling:0, parents:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, Alter), male(Alter).
;; 48
%jichimacu:1, cross_gen[aux]102:0, parents:1, sibling:0, parents:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, Alter), male(Alter).
;; 49
%jichimacu:1, cross_gen[aux]102:0, parents:1, sibling:0, parents:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, Alter), male(Alter).
;; 50
%jichimacu:1, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 51
%jichimacu:1, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, Alter), male(Alter).
;; 52
%jichimacu:1, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 53
%jichimacu:1, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, Alter), male(Alter).
;; 54
%jichimacu:1, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 55
%jichimacu:1, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, Alter), male(Alter).
;; 56
%jichimacu:1, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 57
%jichimacu:1, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, Alter), male(Alter).
;; 58
%jichimacu:1, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 59
%jichimacu:1, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, Alter), male(Alter).
;; 60
%jichimacu:1, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 61
%jichimacu:1, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, Alter), male(Alter).
;; 62
%jichimacu:1, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 63
%jichimacu:1, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, Alter), male(Alter).
;; 64
%jichimacu:1, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, Alter), male(Alter).
;; 65
%jichimacu:1, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, Alter), male(Alter).
;; 66
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), mother(H, Alter), male(Alter).
;; 67
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), father(H, Alter), male(Alter).
;; 68
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 69
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 70
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 71
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 72
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 73
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 74
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 75
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 76
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 77
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 78
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 79
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 80
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 81
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 82
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 83
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 84
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), mother(H, Alter), male(Alter).
;; 85
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), father(H, Alter), male(Alter).
;; 86
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 87
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 88
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 89
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 90
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 91
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 92
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 93
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 94
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 95
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 96
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 97
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 98
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 99
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 100
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 101
%jichimacu:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 102
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), mother(H, Alter), male(Alter).
;; 103
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), father(H, Alter), male(Alter).
;; 104
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 105
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 106
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 107
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 108
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 109
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 110
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 111
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 112
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 113
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 114
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 115
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 116
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 117
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 118
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 119
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 120
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), mother(H, Alter), male(Alter).
;; 121
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), child(H, G), gender(I, A), gender(J, G), not(equal(I, J)), father(H, Alter), male(Alter).
;; 122
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 123
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 124
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 125
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 126
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 127
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 128
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:0%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), mother(K, Alter), male(Alter).
;; 129
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0, parents:1%
 Lvl=-1,  PC=11, S=0, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(B, G), gender(I, B), gender(I, D), child(J, D), child(K, J), gender(L, A), gender(M, J), not(equal(L, M)), father(K, Alter), male(Alter).
;; 130
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 131
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 132
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, Alter), male(Alter).
;; 133
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, Alter), male(Alter).
;; 134
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 135
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 136
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, Alter), male(Alter).
;; 137
%jichimacu:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1%
 Lvl=-1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, Alter), male(Alter).
;; 138
%jichimacu:2, cross_gen[aux]102:0, parents:0, sibling:0, parents:0, parents:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, H), mother(H, Alter), male(Alter).
;; 139
%jichimacu:2, cross_gen[aux]102:0, parents:0, sibling:0, parents:0, parents:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, H), father(H, Alter), male(Alter).
;; 140
%jichimacu:2, cross_gen[aux]102:0, parents:0, sibling:0, parents:1, parents:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, H), mother(H, Alter), male(Alter).
;; 141
%jichimacu:2, cross_gen[aux]102:0, parents:0, sibling:0, parents:1, parents:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, H), father(H, Alter), male(Alter).
;; 142
%jichimacu:2, cross_gen[aux]102:0, parents:1, sibling:0, parents:0, parents:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, H), mother(H, Alter), male(Alter).
;; 143
%jichimacu:2, cross_gen[aux]102:0, parents:1, sibling:0, parents:0, parents:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), mother(G, H), father(H, Alter), male(Alter).
;; 144
%jichimacu:2, cross_gen[aux]102:0, parents:1, sibling:0, parents:1, parents:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, H), mother(H, Alter), male(Alter).
;; 145
%jichimacu:2, cross_gen[aux]102:0, parents:1, sibling:0, parents:1, parents:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(G, C), father(G, H), father(H, Alter), male(Alter).
;; 146
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 147
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 148
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 149
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:0, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 150
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 151
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 152
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 153
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:0, sibling:0, children:1, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 154
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 155
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 156
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 157
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:0, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 158
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 159
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 160
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 161
%jichimacu:2, cross_gen[aux]102:1, parents:0, parents:1, sibling:0, children:1, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 162
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 163
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 164
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 165
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:0, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 166
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 167
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 168
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 169
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:0, sibling:0, children:1, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 170
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 171
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 172
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 173
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:0, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), son(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 174
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:0, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), mother(J, Alter), male(Alter).
;; 175
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:0, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), mother(I, J), father(J, Alter), male(Alter).
;; 176
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:1, parents:0%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), mother(J, Alter), male(Alter).
;; 177
%jichimacu:2, cross_gen[aux]102:1, parents:1, parents:1, sibling:0, children:1, parents:1, parents:1%
 Lvl=-2,  PC=10, S=0, Star=0,  {**}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), daughter(H, D), child(I, H), father(I, J), father(J, Alter), male(Alter).
;; 178
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 179
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 180
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 181
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 182
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 183
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 184
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 185
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 186
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 187
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 188
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 189
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 190
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 191
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 192
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 193
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 194
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 195
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 196
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 197
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).
;; 198
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 199
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 200
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 201
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).
;; 202
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 203
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 204
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 205
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 206
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 207
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 208
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 209
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 210
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 211
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 212
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 213
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 214
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 215
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 216
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 217
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 218
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 219
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 220
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 221
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).
;; 222
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 223
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 224
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 225
%jichimacu:2, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).
;; 226
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 227
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 228
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 229
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 230
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 231
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 232
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 233
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 234
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 235
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 236
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 237
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 238
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 239
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 240
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 241
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 242
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 243
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 244
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 245
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).
;; 246
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 247
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 248
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 249
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).
;; 250
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 251
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 252
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 253
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 254
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 255
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 256
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 257
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 258
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 259
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 260
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 261
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), husband(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 262
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), mother(O, Alter), male(Alter).
;; 263
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), mother(L, O), father(O, Alter), male(Alter).
;; 264
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), mother(O, Alter), male(Alter).
;; 265
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=11, S=2, Star=0,  {**}  
[ext], [ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, D), wife(E, F), spouse(G, E), not(equal(F, G)), child(C, G), child(C, E), child(H, F), gender(I, H), gender(I, C), child(B, H), gender(J, B), gender(J, D), child(K, D), child(L, K), gender(M, A), gender(N, K), not(equal(M, N)), father(L, O), father(O, Alter), male(Alter).
;; 266
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 267
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 268
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 269
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).
;; 270
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), mother(L, Alter), male(Alter).
;; 271
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:0, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), mother(I, L), father(L, Alter), male(Alter).
;; 272
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:0%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), mother(L, Alter), male(Alter).
;; 273
%jichimacu:2, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1, parents:1, parents:1%
 Lvl=-2,  PC=9, S=2, Star=0,  {**}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(F, E), child(F, C), child(B, D), gender(G, B), gender(G, F), child(H, F), child(I, H), gender(J, A), gender(K, H), not(equal(J, K)), father(I, L), father(L, Alter), male(Alter).


jicoyumu(Alter, Ego) :-  wife(A, Ego), sibling(Alter, A), male(Alter).
                     |   male(Ego), sibling(A, Ego), husband(Alter, A).
{"**"}
;; 0
%jicoyumu:0, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), male(Alter).
;; 1
%jicoyumu:1, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {**}  
 male(Ego), mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), husband(Alter, C).


jitebuco(Alter, Ego) :-  husband(A, Ego), sibling(B, A), wife(Alter, B).
                     |  [ext],  husband(A, Ego), parallel_gen[aux]10(B, A), wife(Alter, B).
{"**"}
;; 0
%jitebuco:0, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {**}  
 husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), wife(Alter, D).
;; 1
%jitebuco:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), wife(Alter, D).
;; 2
%jitebuco:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {**}  
[ext], [ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(G, E), gender(H, G), gender(H, A), wife(Alter, G).
;; 3
%jitebuco:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=4, Star=0,  {**}  
[ext], [ext], [ext],  husband(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), wife(Alter, H).
;; 4
%jitebuco:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=4, Star=0,  {**}  
[ext], [ext], [ext],  husband(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), wife(Alter, H).
;; 5
%jitebuco:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {**}  
[ext], [ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(G, E), gender(H, G), gender(H, A), wife(Alter, G).
;; 6
%jitebuco:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=4, Star=0,  {**}  
[ext], [ext], [ext],  husband(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), wife(Alter, H).
;; 7
%jitebuco:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=4, Star=0,  {**}  
[ext], [ext], [ext],  husband(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), wife(Alter, H).
;; 8
%jitebuco:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=3, S=4, Star=0,  {**}  
[ext], [ext],  husband(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), wife(Alter, E).
;; 9
%jitebuco:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=3, S=4, Star=0,  {**}  
[ext], [ext],  husband(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), wife(Alter, E).
;; 10
%jitebuco:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=4, Star=0,  {**}  
[ext], [ext],  husband(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(I, G), gender(J, I), gender(J, A), wife(Alter, I).
;; 11
%jitebuco:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=4, Star=0,  {**}  
[ext], [ext],  husband(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(I, G), gender(J, I), gender(J, A), wife(Alter, I).


jitebucu(Alter, Ego) :-  wife(A, Ego), sibling(B, A), husband(Alter, B).
                     |  [ext],  wife(A, Ego), parallel_gen[aux]10(B, A), husband(Alter, B).
{"**"}
;; 0
%jitebucu:0, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {**}  
 wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), husband(Alter, D).
;; 1
%jitebucu:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), husband(Alter, D).
;; 2
%jitebucu:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {**}  
[ext], [ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(G, E), gender(H, G), gender(H, A), husband(Alter, G).
;; 3
%jitebucu:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=4, Star=0,  {**}  
[ext], [ext], [ext],  wife(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), husband(Alter, H).
;; 4
%jitebucu:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=4, Star=0,  {**}  
[ext], [ext], [ext],  wife(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), husband(Alter, H).
;; 5
%jitebucu:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {**}  
[ext], [ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(G, E), gender(H, G), gender(H, A), husband(Alter, G).
;; 6
%jitebucu:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=4, Star=0,  {**}  
[ext], [ext], [ext],  wife(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), husband(Alter, H).
;; 7
%jitebucu:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=4, Star=0,  {**}  
[ext], [ext], [ext],  wife(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), husband(Alter, H).
;; 8
%jitebucu:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=3, S=4, Star=0,  {**}  
[ext], [ext],  wife(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), husband(Alter, E).
;; 9
%jitebucu:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=3, S=4, Star=0,  {**}  
[ext], [ext],  wife(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), husband(Alter, E).
;; 10
%jitebucu:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=4, Star=0,  {**}  
[ext], [ext],  wife(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(I, G), gender(J, I), gender(J, A), husband(Alter, I).
;; 11
%jitebucu:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=4, Star=0,  {**}  
[ext], [ext],  wife(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(I, G), gender(J, I), gender(J, A), husband(Alter, I).


jiwemo(Alter, Ego) :-  husband(A, Ego), sibling(Alter, A), female(Alter).
                   |   female(Ego), sibling(A, Ego), wife(Alter, A).
{"**"}
;; 0
%jiwemo:0, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), female(Alter).
;; 1
%jiwemo:1, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {**}  
 female(Ego), mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), wife(Alter, C).


juai_co(Alter, Ego) :-  generation[aux]10gs(A, Ego), daughter(Alter, A).
                    |   generation[aux]10gs(A, Ego), children(B, A), daughter(Alter, B).
                    |   spice(A, Ego), generation[aux]10gs(B, A), daughter(Alter, B).
                    |   child_in_law[aux]10(Alter, Ego), female(Alter).
                    |  [ext],  parallel_gen[aux]10(Ego, Alter), elder(Ego, Alter), female(Alter).
                    |  [ext],  *sib_number(A, Ego), *sib_number(A, B), not(equal(Ego, B)), daughter(Alter, B), not(generation[aux]10(B, Ego)).
{"**_Sis"}
;; 0
%juai_co:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=5, S=0, Star=0,  {**}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(Alter, C).
;; 1
%juai_co:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=5, S=0, Star=0,  {**}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(Alter, C).
;; 2
%juai_co:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(Alter, E).
;; 3
%juai_co:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(Alter, E).
;; 4
%juai_co:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(Alter, E).
;; 5
%juai_co:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(Alter, E).
;; 6
%juai_co:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(Alter, E).
;; 7
%juai_co:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(Alter, E).
;; 8
%juai_co:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(Alter, E).
;; 9
%juai_co:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(Alter, E).
;; 10
%juai_co:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), daughter(Alter, D).
;; 11
%juai_co:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), daughter(Alter, D).
;; 12
%juai_co:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), daughter(Alter, D).
;; 13
%juai_co:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), daughter(Alter, D).
;; 14
%juai_co:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(Alter, F).
;; 15
%juai_co:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(Alter, F).
;; 16
%juai_co:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(Alter, F).
;; 17
%juai_co:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(Alter, F).
;; 18
%juai_co:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(Alter, F).
;; 19
%juai_co:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(Alter, F).
;; 20
%juai_co:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(Alter, F).
;; 21
%juai_co:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(Alter, F).
;; 22
%juai_co:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(Alter, F).
;; 23
%juai_co:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(Alter, F).
;; 24
%juai_co:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(Alter, F).
;; 25
%juai_co:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(Alter, F).
;; 26
%juai_co:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(Alter, F).
;; 27
%juai_co:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(Alter, F).
;; 28
%juai_co:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(Alter, F).
;; 29
%juai_co:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(Alter, F).
;; 30
%juai_co:2, spice:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 31
%juai_co:2, spice:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).
;; 32
%juai_co:2, spice:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(Alter, F).
;; 33
%juai_co:2, spice:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(Alter, F).
;; 34
%juai_co:2, spice:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(Alter, F).
;; 35
%juai_co:2, spice:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(Alter, F).
;; 36
%juai_co:2, spice:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(Alter, F).
;; 37
%juai_co:2, spice:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(Alter, F).
;; 38
%juai_co:2, spice:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(Alter, F).
;; 39
%juai_co:2, spice:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(Alter, F).
;; 40
%juai_co:2, spice:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 41
%juai_co:2, spice:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).
;; 42
%juai_co:2, spice:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(Alter, F).
;; 43
%juai_co:2, spice:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(Alter, F).
;; 44
%juai_co:2, spice:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(Alter, F).
;; 45
%juai_co:2, spice:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(Alter, F).
;; 46
%juai_co:2, spice:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(Alter, F).
;; 47
%juai_co:2, spice:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(Alter, F).
;; 48
%juai_co:2, spice:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(Alter, F).
;; 49
%juai_co:2, spice:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(Alter, F).
;; 50
%juai_co:3, child_in_law[aux]10:0%
 Lvl=-1,  PC=1, S=1, Star=0,  {**}  
 child(A, Ego), spouse(Alter, A), female(Alter).
;; 51
%juai_co:3, child_in_law[aux]10:1, spice:0%
 Lvl=-1,  PC=2, S=3, Star=0,  {**}  
[ext],  husband(A, Ego), spouse(B, A), not(equal(Ego, B)), child(C, B), child(C, A), spouse(Alter, C), female(Alter).
;; 52
%juai_co:3, child_in_law[aux]10:1, spice:1%
 Lvl=-1,  PC=2, S=3, Star=0,  {**}  
[ext],  wife(A, Ego), spouse(B, A), not(equal(Ego, B)), child(C, B), child(C, A), spouse(Alter, C), female(Alter).
;; 53
%juai_co:3, child_in_law[aux]10:2, children:0, generation[aux]10:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {**}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 54
%juai_co:3, child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 55
%juai_co:3, child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 56
%juai_co:3, child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  son(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 57
%juai_co:3, child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  son(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 58
%juai_co:3, child_in_law[aux]10:2, children:1, generation[aux]10:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {**}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 59
%juai_co:3, child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 60
%juai_co:3, child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 61
%juai_co:3, child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  daughter(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 62
%juai_co:3, child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  daughter(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 63
%juai_co:3, child_in_law[aux]10:3, children:0, generation[aux]10:0, sibling:0%
 Lvl=-1,  PC=6, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 64
%juai_co:3, child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), female(Alter).
;; 65
%juai_co:3, child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), female(Alter).
;; 66
%juai_co:3, child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), female(Alter).
;; 67
%juai_co:3, child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), female(Alter).
;; 68
%juai_co:3, child_in_law[aux]10:3, children:1, generation[aux]10:0, sibling:0%
 Lvl=-1,  PC=6, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 69
%juai_co:3, child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), female(Alter).
;; 70
%juai_co:3, child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), female(Alter).
;; 71
%juai_co:3, child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), female(Alter).
;; 72
%juai_co:3, child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), female(Alter).
;; 73
%juai_co:4, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {Sis}  
[ext],  mother(A, Alter), father(B, Alter), child(Ego, A), child(Ego, B), not(equal(Ego, Alter)), gender(C, Ego), gender(C, Alter), elder(Ego, Alter), female(Alter).
;; 74
%juai_co:4, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {**}  
[ext], [ext],  mother(A, Alter), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), child(Ego, D), gender(F, Ego), gender(F, Alter), elder(Ego, Alter), female(Alter).
;; 75
%juai_co:4, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Alter), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Ego, E), gender(G, Ego), gender(G, Alter), elder(Ego, Alter), female(Alter).
;; 76
%juai_co:4, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Alter), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Ego, E), gender(G, Ego), gender(G, Alter), elder(Ego, Alter), female(Alter).
;; 77
%juai_co:4, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {**}  
[ext], [ext],  father(A, Alter), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), child(Ego, D), gender(F, Ego), gender(F, Alter), elder(Ego, Alter), female(Alter).
;; 78
%juai_co:4, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Alter), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Ego, E), gender(G, Ego), gender(G, Alter), elder(Ego, Alter), female(Alter).
;; 79
%juai_co:4, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Alter), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Ego, E), gender(G, Ego), gender(G, Alter), elder(Ego, Alter), female(Alter).
;; 80
%juai_co:4, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=3, S=2, Star=0,  {**}  
[ext], [ext],  husband(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), child(Ego, B), gender(D, Ego), gender(D, Alter), elder(Ego, Alter), female(Alter).
;; 81
%juai_co:4, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=3, S=2, Star=0,  {**}  
[ext], [ext],  wife(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), child(Ego, B), gender(D, Ego), gender(D, Alter), elder(Ego, Alter), female(Alter).
;; 82
%juai_co:4, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  husband(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(Ego, F), gender(H, Ego), gender(H, Alter), elder(Ego, Alter), female(Alter).
;; 83
%juai_co:4, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=6, S=4, Star=0,  {**}  
[ext], [ext], [ext],  husband(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), husband(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Ego, G), gender(I, Ego), gender(I, Alter), elder(Ego, Alter), female(Alter).
;; 84
%juai_co:4, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=6, S=4, Star=0,  {**}  
[ext], [ext], [ext],  husband(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), wife(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Ego, G), gender(I, Ego), gender(I, Alter), elder(Ego, Alter), female(Alter).
;; 85
%juai_co:4, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  wife(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(Ego, F), gender(H, Ego), gender(H, Alter), elder(Ego, Alter), female(Alter).
;; 86
%juai_co:4, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=6, S=4, Star=0,  {**}  
[ext], [ext], [ext],  wife(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), husband(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Ego, G), gender(I, Ego), gender(I, Alter), elder(Ego, Alter), female(Alter).
;; 87
%juai_co:4, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=6, S=4, Star=0,  {**}  
[ext], [ext], [ext],  wife(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), wife(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Ego, G), gender(I, Ego), gender(I, Alter), elder(Ego, Alter), female(Alter).
;; 88
%juai_co:5, (not: generation[aux]10:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1)%
 Lvl=-1,  PC=1, S=0, Star=2,  {**}  
[ext],  *sib_number(A, Ego), *sib_number(A, B), not(equal(Ego, B)), daughter(Alter, B), not(mother(C, Ego), father(D, Ego), child(B, C), child(B, D), not(equal(B, Ego))), not(mother(E, Ego), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(B, H)), not(mother(E, Ego), mother(I, E), father(J, E), child(H, I), child(H, J), not(equal(H, E)), female(H), child(B, H)), not(mother(E, Ego), mother(K, E), mother(L, K), father(M, K), child(N, L), child(N, M), not(equal(N, K)), male(N), son(H, N), child(B, H)), not(mother(E, Ego), mother(K, E), mother(L, K), father(M, K), child(N, L), child(N, M), not(equal(N, K)), male(N), daughter(H, N), child(B, H)), not(mother(E, Ego), mother(K, E), mother(O, K), father(P, K), child(N, O), child(N, P), not(equal(N, K)), female(N), son(H, N), child(B, H)), not(mother(E, Ego), mother(K, E), mother(O, K), father(P, K), child(N, O), child(N, P), not(equal(N, K)), female(N), daughter(H, N), child(B, H)), not(mother(E, Ego), father(K, E), mother(Q, K), father(R, K), child(N, Q), child(N, R), not(equal(N, K)), male(N), son(H, N), child(B, H)), not(mother(E, Ego), father(K, E), mother(Q, K), father(R, K), child(N, Q), child(N, R), not(equal(N, K)), male(N), daughter(H, N), child(B, H)), not(mother(E, Ego), father(K, E), mother(S, K), father(T, K), child(N, S), child(N, T), not(equal(N, K)), female(N), son(H, N), child(B, H)), not(mother(E, Ego), father(K, E), mother(S, K), father(T, K), child(N, S), child(N, T), not(equal(N, K)), female(N), daughter(H, N), child(B, H)), not(father(E, Ego), mother(U, E), father(V, E), child(H, U), child(H, V), not(equal(H, E)), male(H), child(B, H)), not(father(E, Ego), mother(W, E), father(X, E), child(H, W), child(H, X), not(equal(H, E)), female(H), child(B, H)), not(father(E, Ego), mother(Y, E), mother(Z, Y), father(AA, Y), child(BB, Z), child(BB, AA), not(equal(BB, Y)), male(BB), son(H, BB), child(B, H)), not(father(E, Ego), mother(Y, E), mother(Z, Y), father(AA, Y), child(BB, Z), child(BB, AA), not(equal(BB, Y)), male(BB), daughter(H, BB), child(B, H)), not(father(E, Ego), mother(Y, E), mother(CC, Y), father(DD, Y), child(BB, CC), child(BB, DD), not(equal(BB, Y)), female(BB), son(H, BB), child(B, H)), not(father(E, Ego), mother(Y, E), mother(CC, Y), father(DD, Y), child(BB, CC), child(BB, DD), not(equal(BB, Y)), female(BB), daughter(H, BB), child(B, H)), not(father(E, Ego), father(Y, E), mother(EE, Y), father(FF, Y), child(BB, EE), child(BB, FF), not(equal(BB, Y)), male(BB), son(H, BB), child(B, H)), not(father(E, Ego), father(Y, E), mother(EE, Y), father(FF, Y), child(BB, EE), child(BB, FF), not(equal(BB, Y)), male(BB), daughter(H, BB), child(B, H)), not(father(E, Ego), father(Y, E), mother(GG, Y), father(HH, Y), child(BB, GG), child(BB, HH), not(equal(BB, Y)), female(BB), son(H, BB), child(B, H)), not(father(E, Ego), father(Y, E), mother(GG, Y), father(HH, Y), child(BB, GG), child(BB, HH), not(equal(BB, Y)), female(BB), daughter(H, BB), child(B, H)).


juai_yo(Alter, Ego) :-  generation[aux]10gs(A, Ego), son(Alter, A).
                    |   generation[aux]10gs(A, Ego), children(B, A), son(Alter, B).
                    |   spice(A, Ego), generation[aux]10gs(B, A), son(Alter, B).
                    |   child_in_law[aux]10(Alter, Ego), male(Alter).
                    |  [ext],  parallel_gen[aux]10(Ego, Alter), elder(Ego, Alter), male(Alter).
                    |  [ext],  *sib_number(A, Ego), *sib_number(A, B), not(equal(Ego, B)), son(Alter, B), not(generation[aux]10(B, Ego)).
{"**"}
;; 0
%juai_yo:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=5, S=0, Star=0,  {**}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(Alter, C).
;; 1
%juai_yo:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=5, S=0, Star=0,  {**}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(Alter, C).
;; 2
%juai_yo:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(Alter, E).
;; 3
%juai_yo:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(Alter, E).
;; 4
%juai_yo:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(Alter, E).
;; 5
%juai_yo:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(Alter, E).
;; 6
%juai_yo:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(Alter, E).
;; 7
%juai_yo:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(Alter, E).
;; 8
%juai_yo:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(Alter, E).
;; 9
%juai_yo:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(Alter, E).
;; 10
%juai_yo:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), son(Alter, D).
;; 11
%juai_yo:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), son(Alter, D).
;; 12
%juai_yo:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), son(Alter, D).
;; 13
%juai_yo:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), son(Alter, D).
;; 14
%juai_yo:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(Alter, F).
;; 15
%juai_yo:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(Alter, F).
;; 16
%juai_yo:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(Alter, F).
;; 17
%juai_yo:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(Alter, F).
;; 18
%juai_yo:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(Alter, F).
;; 19
%juai_yo:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(Alter, F).
;; 20
%juai_yo:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(Alter, F).
;; 21
%juai_yo:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(Alter, F).
;; 22
%juai_yo:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(Alter, F).
;; 23
%juai_yo:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(Alter, F).
;; 24
%juai_yo:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(Alter, F).
;; 25
%juai_yo:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(Alter, F).
;; 26
%juai_yo:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(Alter, F).
;; 27
%juai_yo:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(Alter, F).
;; 28
%juai_yo:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(Alter, F).
;; 29
%juai_yo:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(Alter, F).
;; 30
%juai_yo:2, spice:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 31
%juai_yo:2, spice:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 32
%juai_yo:2, spice:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(Alter, F).
;; 33
%juai_yo:2, spice:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(Alter, F).
;; 34
%juai_yo:2, spice:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(Alter, F).
;; 35
%juai_yo:2, spice:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(Alter, F).
;; 36
%juai_yo:2, spice:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(Alter, F).
;; 37
%juai_yo:2, spice:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(Alter, F).
;; 38
%juai_yo:2, spice:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(Alter, F).
;; 39
%juai_yo:2, spice:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(Alter, F).
;; 40
%juai_yo:2, spice:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 41
%juai_yo:2, spice:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 42
%juai_yo:2, spice:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(Alter, F).
;; 43
%juai_yo:2, spice:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(Alter, F).
;; 44
%juai_yo:2, spice:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(Alter, F).
;; 45
%juai_yo:2, spice:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(Alter, F).
;; 46
%juai_yo:2, spice:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(Alter, F).
;; 47
%juai_yo:2, spice:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(Alter, F).
;; 48
%juai_yo:2, spice:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(Alter, F).
;; 49
%juai_yo:2, spice:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
 wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(Alter, F).
;; 50
%juai_yo:3, child_in_law[aux]10:0%
 Lvl=-1,  PC=1, S=1, Star=0,  {**}  
 child(A, Ego), spouse(Alter, A), male(Alter).
;; 51
%juai_yo:3, child_in_law[aux]10:1, spice:0%
 Lvl=-1,  PC=2, S=3, Star=0,  {**}  
[ext],  husband(A, Ego), spouse(B, A), not(equal(Ego, B)), child(C, B), child(C, A), spouse(Alter, C), male(Alter).
;; 52
%juai_yo:3, child_in_law[aux]10:1, spice:1%
 Lvl=-1,  PC=2, S=3, Star=0,  {**}  
[ext],  wife(A, Ego), spouse(B, A), not(equal(Ego, B)), child(C, B), child(C, A), spouse(Alter, C), male(Alter).
;; 53
%juai_yo:3, child_in_law[aux]10:2, children:0, generation[aux]10:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {**}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 54
%juai_yo:3, child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 55
%juai_yo:3, child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  son(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 56
%juai_yo:3, child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  son(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 57
%juai_yo:3, child_in_law[aux]10:2, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  son(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 58
%juai_yo:3, child_in_law[aux]10:2, children:1, generation[aux]10:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {**}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 59
%juai_yo:3, child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 60
%juai_yo:3, child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  daughter(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 61
%juai_yo:3, child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  daughter(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 62
%juai_yo:3, child_in_law[aux]10:2, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {**}  
[ext],  daughter(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 63
%juai_yo:3, child_in_law[aux]10:3, children:0, generation[aux]10:0, sibling:0%
 Lvl=-1,  PC=6, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 64
%juai_yo:3, child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), male(Alter).
;; 65
%juai_yo:3, child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), male(Alter).
;; 66
%juai_yo:3, child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), male(Alter).
;; 67
%juai_yo:3, child_in_law[aux]10:3, children:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), male(Alter).
;; 68
%juai_yo:3, child_in_law[aux]10:3, children:1, generation[aux]10:0, sibling:0%
 Lvl=-1,  PC=6, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 69
%juai_yo:3, child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), male(Alter).
;; 70
%juai_yo:3, child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), male(Alter).
;; 71
%juai_yo:3, child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), male(Alter).
;; 72
%juai_yo:3, child_in_law[aux]10:3, children:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=8, S=3, Star=0,  {**}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(C, B), child(C, A), spouse(D, C), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), male(Alter).
;; 73
%juai_yo:4, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, Alter), child(Ego, A), child(Ego, B), not(equal(Ego, Alter)), gender(C, Ego), gender(C, Alter), elder(Ego, Alter), male(Alter).
;; 74
%juai_yo:4, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {**}  
[ext], [ext],  mother(A, Alter), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), child(Ego, D), gender(F, Ego), gender(F, Alter), elder(Ego, Alter), male(Alter).
;; 75
%juai_yo:4, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Alter), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Ego, E), gender(G, Ego), gender(G, Alter), elder(Ego, Alter), male(Alter).
;; 76
%juai_yo:4, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Alter), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Ego, E), gender(G, Ego), gender(G, Alter), elder(Ego, Alter), male(Alter).
;; 77
%juai_yo:4, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {**}  
[ext], [ext],  father(A, Alter), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), child(Ego, D), gender(F, Ego), gender(F, Alter), elder(Ego, Alter), male(Alter).
;; 78
%juai_yo:4, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=5, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Alter), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Ego, E), gender(G, Ego), gender(G, Alter), elder(Ego, Alter), male(Alter).
;; 79
%juai_yo:4, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=5, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Alter), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Ego, E), gender(G, Ego), gender(G, Alter), elder(Ego, Alter), male(Alter).
;; 80
%juai_yo:4, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=3, S=2, Star=0,  {**}  
[ext], [ext],  husband(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), child(Ego, B), gender(D, Ego), gender(D, Alter), elder(Ego, Alter), male(Alter).
;; 81
%juai_yo:4, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=3, S=2, Star=0,  {**}  
[ext], [ext],  wife(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), child(Ego, B), gender(D, Ego), gender(D, Alter), elder(Ego, Alter), male(Alter).
;; 82
%juai_yo:4, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  husband(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(Ego, F), gender(H, Ego), gender(H, Alter), elder(Ego, Alter), male(Alter).
;; 83
%juai_yo:4, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=6, S=4, Star=0,  {**}  
[ext], [ext], [ext],  husband(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), husband(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Ego, G), gender(I, Ego), gender(I, Alter), elder(Ego, Alter), male(Alter).
;; 84
%juai_yo:4, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=6, S=4, Star=0,  {**}  
[ext], [ext], [ext],  husband(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), wife(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Ego, G), gender(I, Ego), gender(I, Alter), elder(Ego, Alter), male(Alter).
;; 85
%juai_yo:4, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=7, S=2, Star=0,  {**}  
[ext], [ext],  wife(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(Ego, F), gender(H, Ego), gender(H, Alter), elder(Ego, Alter), male(Alter).
;; 86
%juai_yo:4, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=6, S=4, Star=0,  {**}  
[ext], [ext], [ext],  wife(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), husband(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Ego, G), gender(I, Ego), gender(I, Alter), elder(Ego, Alter), male(Alter).
;; 87
%juai_yo:4, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=6, S=4, Star=0,  {**}  
[ext], [ext], [ext],  wife(A, B), spouse(C, A), not(equal(B, C)), child(Alter, C), child(Alter, A), wife(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Ego, G), gender(I, Ego), gender(I, Alter), elder(Ego, Alter), male(Alter).
;; 88
%juai_yo:5, (not: generation[aux]10:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0), (not: generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1)%
 Lvl=-1,  PC=1, S=0, Star=2,  {**}  
[ext],  *sib_number(A, Ego), *sib_number(A, B), not(equal(Ego, B)), son(Alter, B), not(mother(C, Ego), father(D, Ego), child(B, C), child(B, D), not(equal(B, Ego))), not(mother(E, Ego), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(B, H)), not(mother(E, Ego), mother(I, E), father(J, E), child(H, I), child(H, J), not(equal(H, E)), female(H), child(B, H)), not(mother(E, Ego), mother(K, E), mother(L, K), father(M, K), child(N, L), child(N, M), not(equal(N, K)), male(N), son(H, N), child(B, H)), not(mother(E, Ego), mother(K, E), mother(L, K), father(M, K), child(N, L), child(N, M), not(equal(N, K)), male(N), daughter(H, N), child(B, H)), not(mother(E, Ego), mother(K, E), mother(O, K), father(P, K), child(N, O), child(N, P), not(equal(N, K)), female(N), son(H, N), child(B, H)), not(mother(E, Ego), mother(K, E), mother(O, K), father(P, K), child(N, O), child(N, P), not(equal(N, K)), female(N), daughter(H, N), child(B, H)), not(mother(E, Ego), father(K, E), mother(Q, K), father(R, K), child(N, Q), child(N, R), not(equal(N, K)), male(N), son(H, N), child(B, H)), not(mother(E, Ego), father(K, E), mother(Q, K), father(R, K), child(N, Q), child(N, R), not(equal(N, K)), male(N), daughter(H, N), child(B, H)), not(mother(E, Ego), father(K, E), mother(S, K), father(T, K), child(N, S), child(N, T), not(equal(N, K)), female(N), son(H, N), child(B, H)), not(mother(E, Ego), father(K, E), mother(S, K), father(T, K), child(N, S), child(N, T), not(equal(N, K)), female(N), daughter(H, N), child(B, H)), not(father(E, Ego), mother(U, E), father(V, E), child(H, U), child(H, V), not(equal(H, E)), male(H), child(B, H)), not(father(E, Ego), mother(W, E), father(X, E), child(H, W), child(H, X), not(equal(H, E)), female(H), child(B, H)), not(father(E, Ego), mother(Y, E), mother(Z, Y), father(AA, Y), child(BB, Z), child(BB, AA), not(equal(BB, Y)), male(BB), son(H, BB), child(B, H)), not(father(E, Ego), mother(Y, E), mother(Z, Y), father(AA, Y), child(BB, Z), child(BB, AA), not(equal(BB, Y)), male(BB), daughter(H, BB), child(B, H)), not(father(E, Ego), mother(Y, E), mother(CC, Y), father(DD, Y), child(BB, CC), child(BB, DD), not(equal(BB, Y)), female(BB), son(H, BB), child(B, H)), not(father(E, Ego), mother(Y, E), mother(CC, Y), father(DD, Y), child(BB, CC), child(BB, DD), not(equal(BB, Y)), female(BB), daughter(H, BB), child(B, H)), not(father(E, Ego), father(Y, E), mother(EE, Y), father(FF, Y), child(BB, EE), child(BB, FF), not(equal(BB, Y)), male(BB), son(H, BB), child(B, H)), not(father(E, Ego), father(Y, E), mother(EE, Y), father(FF, Y), child(BB, EE), child(BB, FF), not(equal(BB, Y)), male(BB), daughter(H, BB), child(B, H)), not(father(E, Ego), father(Y, E), mother(GG, Y), father(HH, Y), child(BB, GG), child(BB, HH), not(equal(BB, Y)), female(BB), son(H, BB), child(B, H)), not(father(E, Ego), father(Y, E), mother(GG, Y), father(HH, Y), child(BB, GG), child(BB, HH), not(equal(BB, Y)), female(BB), daughter(H, BB), child(B, H)).


neco(Alter, Ego) :-  grandparent[aux]10es(Alter, Ego), female(Alter).
{"**_FaMo_MoMo"}
;; 0
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:0, parents:0%
 Lvl=2,  PC=2, S=0, Star=0,  {MoMo}  
 mother(A, Ego), parent(Alter, A), female(Alter).
;; 1
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:0, parents:1%
 Lvl=2,  PC=2, S=0, Star=0,  {FaMo}  
 father(A, Ego), parent(Alter, A), female(Alter).
;; 2
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 3
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 4
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 5
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 6
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 7
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), parent(Alter, B), female(Alter).
;; 8
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 9
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 10
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 11
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 12
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 13
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), parent(Alter, C), female(Alter).
;; 14
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 15
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 16
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 17
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 18
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 19
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), parent(Alter, C), female(Alter).
;; 20
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 21
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 22
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 23
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 24
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 25
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), parent(Alter, B), female(Alter).
;; 26
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 27
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 28
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 29
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 30
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 31
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), parent(Alter, C), female(Alter).
;; 32
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 33
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 34
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 35
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 36
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 37
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), parent(Alter, C), female(Alter).
;; 38
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 39
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 40
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 41
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 42
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 43
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), parent(Alter, B), female(Alter).
;; 44
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 45
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 46
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 47
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 48
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 49
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), parent(Alter, C), female(Alter).
;; 50
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 51
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 52
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 53
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 54
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 55
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), parent(Alter, C), female(Alter).
;; 56
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 57
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 58
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 59
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 60
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 61
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), parent(Alter, B), female(Alter).
;; 62
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 63
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 64
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 65
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 66
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 67
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), parent(Alter, C), female(Alter).
;; 68
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 69
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 70
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 71
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 72
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 73
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), parent(Alter, C), female(Alter).
;; 74
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), female(Alter).
;; 75
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 76
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 77
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 78
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 79
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), parent(C, B), spouse(Alter, C), female(Alter).
;; 80
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 81
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 82
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 83
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 84
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), female(Alter).
;; 85
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 86
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 87
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 88
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 89
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), parent(C, B), spouse(Alter, C), female(Alter).
;; 90
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 91
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 92
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 93
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 94
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), female(Alter).
;; 95
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 96
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 97
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 98
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 99
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), parent(C, B), spouse(Alter, C), female(Alter).
;; 100
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 101
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 102
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 103
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 104
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), female(Alter).
;; 105
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 106
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 107
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 108
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 109
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), parent(C, B), spouse(Alter, C), female(Alter).
;; 110
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 111
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 112
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 113
%neco:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 114
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:0, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), parent(Alter, B), female(Alter).
;; 115
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:0, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {**}  
 husband(A, Ego), father(B, A), parent(Alter, B), female(Alter).
;; 116
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 117
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 118
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 119
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 120
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 121
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), parent(Alter, C), female(Alter).
;; 122
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 123
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), parent(Alter, D), female(Alter).
;; 124
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 125
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), parent(Alter, D), female(Alter).
;; 126
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 127
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 128
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 129
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 130
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 131
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), parent(Alter, C), female(Alter).
;; 132
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 133
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), parent(Alter, D), female(Alter).
;; 134
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 135
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), parent(Alter, D), female(Alter).
;; 136
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 137
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 138
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 139
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 140
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 141
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), parent(Alter, C), female(Alter).
;; 142
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 143
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), parent(Alter, D), female(Alter).
;; 144
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 145
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), parent(Alter, D), female(Alter).
;; 146
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 147
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 148
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 149
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 150
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 151
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), parent(Alter, C), female(Alter).
;; 152
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 153
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), parent(Alter, D), female(Alter).
;; 154
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 155
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), parent(Alter, D), female(Alter).
;; 156
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 157
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 158
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 159
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 160
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 161
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 162
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 163
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 164
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 165
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 166
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 167
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 168
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 169
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 170
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 171
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 172
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 173
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 174
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 175
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 176
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 177
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 178
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 179
%neco:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 180
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:0, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), parent(Alter, B), female(Alter).
;; 181
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:0, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {**}  
 wife(A, Ego), father(B, A), parent(Alter, B), female(Alter).
;; 182
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 183
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 184
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 185
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 186
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 187
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), parent(Alter, C), female(Alter).
;; 188
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 189
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), parent(Alter, D), female(Alter).
;; 190
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 191
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), parent(Alter, D), female(Alter).
;; 192
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 193
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 194
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 195
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 196
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 197
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), parent(Alter, C), female(Alter).
;; 198
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 199
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), parent(Alter, D), female(Alter).
;; 200
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 201
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), parent(Alter, D), female(Alter).
;; 202
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 203
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 204
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 205
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 206
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 207
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), parent(Alter, C), female(Alter).
;; 208
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 209
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), parent(Alter, D), female(Alter).
;; 210
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 211
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), parent(Alter, D), female(Alter).
;; 212
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 213
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 214
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 215
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 216
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 217
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), parent(Alter, C), female(Alter).
;; 218
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 219
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), parent(Alter, D), female(Alter).
;; 220
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 221
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), parent(Alter, D), female(Alter).
;; 222
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 223
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 224
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 225
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 226
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 227
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 228
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 229
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 230
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 231
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 232
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 233
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 234
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 235
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 236
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 237
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 238
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 239
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 240
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 241
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D), female(Alter).
;; 242
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 243
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Alter, E), female(Alter).
;; 244
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), female(Alter).
;; 245
%neco:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), parent(E, D), spouse(Alter, E), female(Alter).


necuyo(Alter, Ego) :-  grandparent[aux]10es(Alter, Ego), male(Alter).
{"**_FaFa_MoFa"}
;; 0
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:0, parents:0%
 Lvl=2,  PC=2, S=0, Star=0,  {MoFa}  
 mother(A, Ego), parent(Alter, A), male(Alter).
;; 1
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:0, parents:1%
 Lvl=2,  PC=2, S=0, Star=0,  {FaFa}  
 father(A, Ego), parent(Alter, A), male(Alter).
;; 2
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 3
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 4
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 5
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 6
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 7
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), parent(Alter, B), male(Alter).
;; 8
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 9
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 10
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 11
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 12
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 13
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), parent(Alter, C), male(Alter).
;; 14
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 15
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 16
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 17
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 18
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 19
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), parent(Alter, C), male(Alter).
;; 20
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 21
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 22
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 23
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 24
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 25
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), parent(Alter, B), male(Alter).
;; 26
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 27
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 28
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 29
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 30
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 31
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), parent(Alter, C), male(Alter).
;; 32
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 33
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 34
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 35
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 36
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 37
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), parent(Alter, C), male(Alter).
;; 38
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 39
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 40
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 41
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 42
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 43
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), parent(Alter, B), male(Alter).
;; 44
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 45
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 46
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 47
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 48
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 49
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), parent(Alter, C), male(Alter).
;; 50
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 51
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 52
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 53
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 54
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 55
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), parent(Alter, C), male(Alter).
;; 56
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 57
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 58
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 59
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 60
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 61
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), parent(Alter, B), male(Alter).
;; 62
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 63
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 64
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 65
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 66
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 67
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), parent(Alter, C), male(Alter).
;; 68
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 69
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 70
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 71
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 72
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 73
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), parent(Alter, C), male(Alter).
;; 74
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), male(Alter).
;; 75
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 76
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 77
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 78
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 79
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), parent(C, B), spouse(Alter, C), male(Alter).
;; 80
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 81
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 82
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 83
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 84
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), male(Alter).
;; 85
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 86
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 87
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 88
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 89
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), parent(C, B), spouse(Alter, C), male(Alter).
;; 90
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 91
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 92
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 93
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 94
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), male(Alter).
;; 95
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 96
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 97
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 98
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 99
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), parent(C, B), spouse(Alter, C), male(Alter).
;; 100
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 101
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 102
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 103
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 104
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), male(Alter).
;; 105
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 106
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 107
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 108
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 109
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), parent(C, B), spouse(Alter, C), male(Alter).
;; 110
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 111
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 112
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 113
%necuyo:0, grandparent[aux]10es:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 114
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:0, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {**}  
 husband(A, Ego), mother(B, A), parent(Alter, B), male(Alter).
;; 115
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:0, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {**}  
 husband(A, Ego), father(B, A), parent(Alter, B), male(Alter).
;; 116
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 117
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 118
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 119
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 120
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 121
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), parent(Alter, C), male(Alter).
;; 122
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 123
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), parent(Alter, D), male(Alter).
;; 124
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 125
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), parent(Alter, D), male(Alter).
;; 126
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 127
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 128
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 129
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 130
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 131
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), parent(Alter, C), male(Alter).
;; 132
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 133
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), parent(Alter, D), male(Alter).
;; 134
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 135
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), parent(Alter, D), male(Alter).
;; 136
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 137
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 138
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 139
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 140
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 141
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), parent(Alter, C), male(Alter).
;; 142
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 143
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), parent(Alter, D), male(Alter).
;; 144
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 145
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), parent(Alter, D), male(Alter).
;; 146
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 147
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 148
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 149
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 150
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 151
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), parent(Alter, C), male(Alter).
;; 152
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 153
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), parent(Alter, D), male(Alter).
;; 154
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 155
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), parent(Alter, D), male(Alter).
;; 156
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 157
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 158
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 159
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 160
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 161
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 162
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 163
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 164
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 165
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 166
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 167
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 168
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 169
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 170
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 171
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 172
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 173
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 174
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 175
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 176
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 177
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 178
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 179
%necuyo:0, grandparent[aux]10es:1, spice:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 180
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:0, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {**}  
 wife(A, Ego), mother(B, A), parent(Alter, B), male(Alter).
;; 181
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:0, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {**}  
 wife(A, Ego), father(B, A), parent(Alter, B), male(Alter).
;; 182
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 183
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 184
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 185
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 186
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 187
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), parent(Alter, C), male(Alter).
;; 188
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 189
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), parent(Alter, D), male(Alter).
;; 190
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 191
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), parent(Alter, D), male(Alter).
;; 192
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 193
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 194
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 195
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 196
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 197
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), parent(Alter, C), male(Alter).
;; 198
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 199
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), parent(Alter, D), male(Alter).
;; 200
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 201
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), parent(Alter, D), male(Alter).
;; 202
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 203
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 204
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 205
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 206
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 207
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), parent(Alter, C), male(Alter).
;; 208
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 209
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), parent(Alter, D), male(Alter).
;; 210
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 211
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), parent(Alter, D), male(Alter).
;; 212
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 213
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 214
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 215
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 216
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 217
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), parent(Alter, C), male(Alter).
;; 218
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 219
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), parent(Alter, D), male(Alter).
;; 220
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 221
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), parent(Alter, D), male(Alter).
;; 222
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 223
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 224
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 225
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 226
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 227
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 228
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 229
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 230
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 231
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 232
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 233
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 234
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 235
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 236
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 237
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 238
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 239
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 240
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=2,  PC=6, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 241
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=3,  PC=3, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), parent(D, C), spouse(Alter, D), male(Alter).
;; 242
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 243
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Alter, E), male(Alter).
;; 244
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Alter, G), male(Alter).
;; 245
%necuyo:0, grandparent[aux]10es:1, spice:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=4,  PC=4, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), parent(E, D), spouse(Alter, E), male(Alter).


paco(Alter, Ego) :-  mother(A, Ego), parallel_gen[aux]10(A, Alter).
                 |  [ext],  father(A, Ego), parallel_gen[aux]10(A, B), wife(Alter, B).
{"**_FaBroWi_FaHbroWi_MoHsis_MoSis"}
;; 0
%paco:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=0, Star=0,  {MoSis}  
 mother(A, Ego), mother(B, Alter), father(C, Alter), child(A, B), child(A, C), not(equal(A, Alter)), gender(D, A), gender(D, Alter).
;; 1
%paco:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, Alter), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(A, E), gender(G, A), gender(G, Alter).
;; 2
%paco:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, Alter), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(A, F), gender(H, A), gender(H, Alter).
;; 3
%paco:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, Alter), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(A, F), gender(H, A), gender(H, Alter).
;; 4
%paco:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, Alter), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(A, E), gender(G, A), gender(G, Alter).
;; 5
%paco:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, Alter), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(A, F), gender(H, A), gender(H, Alter).
;; 6
%paco:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, Alter), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(A, F), gender(H, A), gender(H, Alter).
;; 7
%paco:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=4, S=2, Star=0,  {MoHsis}  
[ext],  mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(Alter, D), child(Alter, B), child(A, C), gender(E, A), gender(E, Alter).
;; 8
%paco:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=4, S=2, Star=0,  {MoHsis}  
[ext],  mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(Alter, D), child(Alter, B), child(A, C), gender(E, A), gender(E, Alter).
;; 9
%paco:0, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(Alter, D), child(Alter, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(A, G), gender(I, A), gender(I, Alter).
;; 10
%paco:0, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(Alter, D), child(Alter, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(A, G), gender(I, A), gender(I, Alter).
;; 11
%paco:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {FaBroWi}  
[ext],  father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(E, C), wife(Alter, C).
;; 12
%paco:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, C), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(A, F), gender(H, A), gender(H, C), wife(Alter, C).
;; 13
%paco:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, C), husband(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(A, G), gender(I, A), gender(I, C), wife(Alter, C).
;; 14
%paco:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, C), wife(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(A, G), gender(I, A), gender(I, C), wife(Alter, C).
;; 15
%paco:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, C), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(A, F), gender(H, A), gender(H, C), wife(Alter, C).
;; 16
%paco:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, C), husband(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(A, G), gender(I, A), gender(I, C), wife(Alter, C).
;; 17
%paco:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, C), wife(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(A, G), gender(I, A), gender(I, C), wife(Alter, C).
;; 18
%paco:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=4, S=3, Star=0,  {FaHbroWi}  
[ext], [ext],  father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), child(A, C), gender(F, A), gender(F, E), wife(Alter, E).
;; 19
%paco:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=4, S=3, Star=0,  {FaHbroWi}  
[ext], [ext],  father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), child(A, C), gender(F, A), gender(F, E), wife(Alter, E).
;; 20
%paco:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=8, S=3, Star=0,  {**}  
[ext], [ext],  father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), mother(F, C), father(G, C), child(H, F), child(H, G), not(equal(H, C)), gender(I, H), gender(I, C), child(A, H), gender(J, A), gender(J, E), wife(Alter, E).
;; 21
%paco:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=7, S=5, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), husband(F, G), spouse(H, F), not(equal(G, H)), child(C, H), child(C, F), child(I, G), gender(J, I), gender(J, C), child(A, I), gender(K, A), gender(K, E), wife(Alter, E).
;; 22
%paco:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=7, S=5, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), wife(F, G), spouse(H, F), not(equal(G, H)), child(C, H), child(C, F), child(I, G), gender(J, I), gender(J, C), child(A, I), gender(K, A), gender(K, E), wife(Alter, E).
;; 23
%paco:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=8, S=3, Star=0,  {**}  
[ext], [ext],  father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), mother(F, C), father(G, C), child(H, F), child(H, G), not(equal(H, C)), gender(I, H), gender(I, C), child(A, H), gender(J, A), gender(J, E), wife(Alter, E).
;; 24
%paco:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=7, S=5, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), husband(F, G), spouse(H, F), not(equal(G, H)), child(C, H), child(C, F), child(I, G), gender(J, I), gender(J, C), child(A, I), gender(K, A), gender(K, E), wife(Alter, E).
;; 25
%paco:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=7, S=5, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), wife(F, G), spouse(H, F), not(equal(G, H)), child(C, H), child(C, F), child(I, G), gender(J, I), gender(J, C), child(A, I), gender(K, A), gender(K, E), wife(Alter, E).


pacu(Alter, Ego) :-  father(Alter, Ego).
{"Fa"}
;; 0
%pacu:0%
 Lvl=1,  PC=1, S=0, Star=0,  {Fa}  
 father(Alter, Ego).


pacu_yo(Alter, Ego) :-  father(A, Ego), parallel_gen[aux]10(A, Alter).
                    |  [ext],  mother(A, Ego), parallel_gen[aux]10(A, B), husband(Alter, B).
{"**_FaBro_FaHbro_MoHsisHu_MoSisHu"}
;; 0
%pacu_yo:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=0, Star=0,  {FaBro}  
 father(A, Ego), mother(B, Alter), father(C, Alter), child(A, B), child(A, C), not(equal(A, Alter)), gender(D, A), gender(D, Alter).
;; 1
%pacu_yo:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, Alter), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(A, E), gender(G, A), gender(G, Alter).
;; 2
%pacu_yo:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, Alter), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(A, F), gender(H, A), gender(H, Alter).
;; 3
%pacu_yo:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, Alter), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(A, F), gender(H, A), gender(H, Alter).
;; 4
%pacu_yo:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, Alter), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(A, E), gender(G, A), gender(G, Alter).
;; 5
%pacu_yo:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, Alter), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(A, F), gender(H, A), gender(H, Alter).
;; 6
%pacu_yo:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, Alter), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(A, F), gender(H, A), gender(H, Alter).
;; 7
%pacu_yo:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=4, S=2, Star=0,  {FaHbro}  
[ext],  father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(Alter, D), child(Alter, B), child(A, C), gender(E, A), gender(E, Alter).
;; 8
%pacu_yo:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=4, S=2, Star=0,  {FaHbro}  
[ext],  father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(Alter, D), child(Alter, B), child(A, C), gender(E, A), gender(E, Alter).
;; 9
%pacu_yo:0, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(Alter, D), child(Alter, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(A, G), gender(I, A), gender(I, Alter).
;; 10
%pacu_yo:0, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(Alter, D), child(Alter, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(A, G), gender(I, A), gender(I, Alter).
;; 11
%pacu_yo:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {MoSisHu}  
[ext],  mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(E, C), husband(Alter, C).
;; 12
%pacu_yo:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, C), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(A, F), gender(H, A), gender(H, C), husband(Alter, C).
;; 13
%pacu_yo:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, C), husband(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(A, G), gender(I, A), gender(I, C), husband(Alter, C).
;; 14
%pacu_yo:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, C), wife(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(A, G), gender(I, A), gender(I, C), husband(Alter, C).
;; 15
%pacu_yo:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, C), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(A, F), gender(H, A), gender(H, C), husband(Alter, C).
;; 16
%pacu_yo:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, C), husband(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(A, G), gender(I, A), gender(I, C), husband(Alter, C).
;; 17
%pacu_yo:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, C), wife(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(A, G), gender(I, A), gender(I, C), husband(Alter, C).
;; 18
%pacu_yo:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=4, S=3, Star=0,  {MoHsisHu}  
[ext], [ext],  mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), child(A, C), gender(F, A), gender(F, E), husband(Alter, E).
;; 19
%pacu_yo:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=4, S=3, Star=0,  {MoHsisHu}  
[ext], [ext],  mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), child(A, C), gender(F, A), gender(F, E), husband(Alter, E).
;; 20
%pacu_yo:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=8, S=3, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), mother(F, C), father(G, C), child(H, F), child(H, G), not(equal(H, C)), gender(I, H), gender(I, C), child(A, H), gender(J, A), gender(J, E), husband(Alter, E).
;; 21
%pacu_yo:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=7, S=5, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), husband(F, G), spouse(H, F), not(equal(G, H)), child(C, H), child(C, F), child(I, G), gender(J, I), gender(J, C), child(A, I), gender(K, A), gender(K, E), husband(Alter, E).
;; 22
%pacu_yo:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=7, S=5, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), wife(F, G), spouse(H, F), not(equal(G, H)), child(C, H), child(C, F), child(I, G), gender(J, I), gender(J, C), child(A, I), gender(K, A), gender(K, E), husband(Alter, E).
;; 23
%pacu_yo:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=8, S=3, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), mother(F, C), father(G, C), child(H, F), child(H, G), not(equal(H, C)), gender(I, H), gender(I, C), child(A, H), gender(J, A), gender(J, E), husband(Alter, E).
;; 24
%pacu_yo:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=7, S=5, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), husband(F, G), spouse(H, F), not(equal(G, H)), child(C, H), child(C, F), child(I, G), gender(J, I), gender(J, C), child(A, I), gender(K, A), gender(K, E), husband(Alter, E).
;; 25
%pacu_yo:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=7, S=5, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(E, D), child(E, B), wife(F, G), spouse(H, F), not(equal(G, H)), child(C, H), child(C, F), child(I, G), gender(J, I), gender(J, C), child(A, I), gender(K, A), gender(K, E), husband(Alter, E).


parajico(Alter, Ego) :-  grandparent[aux]10(Ego, Alter), male(Ego), female(Alter).
                     |   grandparent[aux]10(Ego, Alter), female(Ego), female(Alter).
{"**"}
;; 0
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:0, parents:0%
 Lvl=-2,  PC=2, S=0, Star=0,  {**}  
 mother(A, Alter), parent(Ego, A), male(Ego), female(Alter).
;; 1
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:0, parents:1%
 Lvl=-2,  PC=2, S=0, Star=0,  {**}  
 father(A, Alter), parent(Ego, A), male(Ego), female(Alter).
;; 2
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego), female(Alter).
;; 3
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), female(Alter).
;; 4
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), female(Alter).
;; 5
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), female(Alter).
;; 6
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), female(Alter).
;; 7
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), parent(Ego, B), male(Ego), female(Alter).
;; 8
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), female(Alter).
;; 9
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 10
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 11
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 12
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 13
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), parent(Ego, C), male(Ego), female(Alter).
;; 14
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), female(Alter).
;; 15
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 16
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 17
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 18
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 19
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), parent(Ego, C), male(Ego), female(Alter).
;; 20
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego), female(Alter).
;; 21
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), female(Alter).
;; 22
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), female(Alter).
;; 23
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), female(Alter).
;; 24
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), female(Alter).
;; 25
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), parent(Ego, B), male(Ego), female(Alter).
;; 26
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), female(Alter).
;; 27
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 28
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 29
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 30
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 31
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), parent(Ego, C), male(Ego), female(Alter).
;; 32
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), female(Alter).
;; 33
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 34
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 35
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 36
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 37
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), parent(Ego, C), male(Ego), female(Alter).
;; 38
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego), female(Alter).
;; 39
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), female(Alter).
;; 40
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), female(Alter).
;; 41
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), female(Alter).
;; 42
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), female(Alter).
;; 43
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), parent(Ego, B), male(Ego), female(Alter).
;; 44
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), female(Alter).
;; 45
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 46
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 47
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 48
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 49
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), parent(Ego, C), male(Ego), female(Alter).
;; 50
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), female(Alter).
;; 51
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 52
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 53
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 54
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 55
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), parent(Ego, C), male(Ego), female(Alter).
;; 56
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego), female(Alter).
;; 57
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), female(Alter).
;; 58
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), female(Alter).
;; 59
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), female(Alter).
;; 60
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), female(Alter).
;; 61
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), parent(Ego, B), male(Ego), female(Alter).
;; 62
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), female(Alter).
;; 63
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 64
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 65
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 66
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 67
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), parent(Ego, C), male(Ego), female(Alter).
;; 68
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), female(Alter).
;; 69
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 70
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 71
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 72
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 73
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), parent(Ego, C), male(Ego), female(Alter).
;; 74
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Ego), female(Alter).
;; 75
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 76
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 77
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 78
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 79
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), parent(C, B), spouse(Ego, C), male(Ego), female(Alter).
;; 80
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), female(Alter).
;; 81
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), parent(D, C), spouse(Ego, D), male(Ego), female(Alter).
;; 82
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), female(Alter).
;; 83
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), parent(D, C), spouse(Ego, D), male(Ego), female(Alter).
;; 84
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Ego), female(Alter).
;; 85
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 86
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 87
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 88
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 89
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), parent(C, B), spouse(Ego, C), male(Ego), female(Alter).
;; 90
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), female(Alter).
;; 91
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), parent(D, C), spouse(Ego, D), male(Ego), female(Alter).
;; 92
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), female(Alter).
;; 93
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), parent(D, C), spouse(Ego, D), male(Ego), female(Alter).
;; 94
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Ego), female(Alter).
;; 95
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 96
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 97
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 98
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 99
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), parent(C, B), spouse(Ego, C), male(Ego), female(Alter).
;; 100
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), female(Alter).
;; 101
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), parent(D, C), spouse(Ego, D), male(Ego), female(Alter).
;; 102
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), female(Alter).
;; 103
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), parent(D, C), spouse(Ego, D), male(Ego), female(Alter).
;; 104
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Ego), female(Alter).
;; 105
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 106
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 107
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 108
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), female(Alter).
;; 109
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), parent(C, B), spouse(Ego, C), male(Ego), female(Alter).
;; 110
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), female(Alter).
;; 111
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), parent(D, C), spouse(Ego, D), male(Ego), female(Alter).
;; 112
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), female(Alter).
;; 113
%parajico:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), parent(D, C), spouse(Ego, D), male(Ego), female(Alter).
;; 114
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:0, parents:0%
 Lvl=-2,  PC=2, S=1, Star=0,  {**}  
 spouse(A, Alter), mother(B, A), parent(Ego, B), male(Ego), female(Alter).
;; 115
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:0, parents:1%
 Lvl=-2,  PC=2, S=1, Star=0,  {**}  
 spouse(A, Alter), father(B, A), parent(Ego, B), male(Ego), female(Alter).
;; 116
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), female(Alter).
;; 117
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 118
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 119
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 120
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 121
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), parent(Ego, C), male(Ego), female(Alter).
;; 122
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), female(Alter).
;; 123
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), parent(Ego, D), male(Ego), female(Alter).
;; 124
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), female(Alter).
;; 125
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), parent(Ego, D), male(Ego), female(Alter).
;; 126
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), female(Alter).
;; 127
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 128
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 129
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 130
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 131
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), parent(Ego, C), male(Ego), female(Alter).
;; 132
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), female(Alter).
;; 133
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), parent(Ego, D), male(Ego), female(Alter).
;; 134
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), female(Alter).
;; 135
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), parent(Ego, D), male(Ego), female(Alter).
;; 136
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), female(Alter).
;; 137
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 138
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 139
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 140
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 141
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), parent(Ego, C), male(Ego), female(Alter).
;; 142
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), female(Alter).
;; 143
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), parent(Ego, D), male(Ego), female(Alter).
;; 144
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), female(Alter).
;; 145
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), parent(Ego, D), male(Ego), female(Alter).
;; 146
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), female(Alter).
;; 147
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 148
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 149
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), female(Alter).
;; 150
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), female(Alter).
;; 151
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), parent(Ego, C), male(Ego), female(Alter).
;; 152
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), female(Alter).
;; 153
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), parent(Ego, D), male(Ego), female(Alter).
;; 154
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), female(Alter).
;; 155
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), parent(Ego, D), male(Ego), female(Alter).
;; 156
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), female(Alter).
;; 157
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), parent(D, C), spouse(Ego, D), male(Ego), female(Alter).
;; 158
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), female(Alter).
;; 159
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Ego, E), male(Ego), female(Alter).
;; 160
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), female(Alter).
;; 161
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Ego, E), male(Ego), female(Alter).
;; 162
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), female(Alter).
;; 163
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), parent(D, C), spouse(Ego, D), male(Ego), female(Alter).
;; 164
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), female(Alter).
;; 165
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Ego, E), male(Ego), female(Alter).
;; 166
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), female(Alter).
;; 167
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), parent(E, D), spouse(Ego, E), male(Ego), female(Alter).
;; 168
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), female(Alter).
;; 169
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), parent(D, C), spouse(Ego, D), male(Ego), female(Alter).
;; 170
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), female(Alter).
;; 171
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Ego, E), male(Ego), female(Alter).
;; 172
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), female(Alter).
;; 173
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Ego, E), male(Ego), female(Alter).
;; 174
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), female(Alter).
;; 175
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), parent(D, C), spouse(Ego, D), male(Ego), female(Alter).
;; 176
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), female(Alter).
;; 177
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Ego, E), male(Ego), female(Alter).
;; 178
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), female(Alter).
;; 179
%parajico:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), parent(E, D), spouse(Ego, E), male(Ego), female(Alter).
;; 180
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:0, parents:0%
 Lvl=-2,  PC=2, S=0, Star=0,  {**}  
 mother(A, Alter), parent(Ego, A), female(Ego), female(Alter).
;; 181
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:0, parents:1%
 Lvl=-2,  PC=2, S=0, Star=0,  {**}  
 father(A, Alter), parent(Ego, A), female(Ego), female(Alter).
;; 182
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego), female(Alter).
;; 183
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), female(Alter).
;; 184
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), female(Alter).
;; 185
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), female(Alter).
;; 186
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), female(Alter).
;; 187
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), parent(Ego, B), female(Ego), female(Alter).
;; 188
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), female(Alter).
;; 189
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 190
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 191
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 192
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 193
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), parent(Ego, C), female(Ego), female(Alter).
;; 194
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), female(Alter).
;; 195
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 196
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 197
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 198
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 199
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), parent(Ego, C), female(Ego), female(Alter).
;; 200
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego), female(Alter).
;; 201
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), female(Alter).
;; 202
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), female(Alter).
;; 203
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), female(Alter).
;; 204
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), female(Alter).
;; 205
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), parent(Ego, B), female(Ego), female(Alter).
;; 206
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), female(Alter).
;; 207
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 208
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 209
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 210
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 211
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), parent(Ego, C), female(Ego), female(Alter).
;; 212
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), female(Alter).
;; 213
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 214
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 215
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 216
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 217
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), parent(Ego, C), female(Ego), female(Alter).
;; 218
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego), female(Alter).
;; 219
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), female(Alter).
;; 220
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), female(Alter).
;; 221
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), female(Alter).
;; 222
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), female(Alter).
;; 223
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), parent(Ego, B), female(Ego), female(Alter).
;; 224
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), female(Alter).
;; 225
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 226
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 227
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 228
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 229
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), parent(Ego, C), female(Ego), female(Alter).
;; 230
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), female(Alter).
;; 231
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 232
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 233
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 234
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 235
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), parent(Ego, C), female(Ego), female(Alter).
;; 236
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego), female(Alter).
;; 237
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), female(Alter).
;; 238
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), female(Alter).
;; 239
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), female(Alter).
;; 240
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), female(Alter).
;; 241
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), parent(Ego, B), female(Ego), female(Alter).
;; 242
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), female(Alter).
;; 243
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 244
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 245
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 246
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 247
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), parent(Ego, C), female(Ego), female(Alter).
;; 248
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), female(Alter).
;; 249
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 250
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 251
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 252
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 253
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), parent(Ego, C), female(Ego), female(Alter).
;; 254
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Ego), female(Alter).
;; 255
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 256
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 257
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 258
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 259
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), parent(C, B), spouse(Ego, C), female(Ego), female(Alter).
;; 260
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), female(Alter).
;; 261
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), parent(D, C), spouse(Ego, D), female(Ego), female(Alter).
;; 262
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), female(Alter).
;; 263
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), parent(D, C), spouse(Ego, D), female(Ego), female(Alter).
;; 264
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Ego), female(Alter).
;; 265
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 266
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 267
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 268
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 269
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), parent(C, B), spouse(Ego, C), female(Ego), female(Alter).
;; 270
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), female(Alter).
;; 271
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), parent(D, C), spouse(Ego, D), female(Ego), female(Alter).
;; 272
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), female(Alter).
;; 273
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), parent(D, C), spouse(Ego, D), female(Ego), female(Alter).
;; 274
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Ego), female(Alter).
;; 275
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 276
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 277
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 278
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 279
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), parent(C, B), spouse(Ego, C), female(Ego), female(Alter).
;; 280
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), female(Alter).
;; 281
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), parent(D, C), spouse(Ego, D), female(Ego), female(Alter).
;; 282
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), female(Alter).
;; 283
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), parent(D, C), spouse(Ego, D), female(Ego), female(Alter).
;; 284
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Ego), female(Alter).
;; 285
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 286
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 287
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 288
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), female(Alter).
;; 289
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), parent(C, B), spouse(Ego, C), female(Ego), female(Alter).
;; 290
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), female(Alter).
;; 291
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), parent(D, C), spouse(Ego, D), female(Ego), female(Alter).
;; 292
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), female(Alter).
;; 293
%parajico:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), parent(D, C), spouse(Ego, D), female(Ego), female(Alter).
;; 294
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:0, parents:0%
 Lvl=-2,  PC=2, S=1, Star=0,  {**}  
 spouse(A, Alter), mother(B, A), parent(Ego, B), female(Ego), female(Alter).
;; 295
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:0, parents:1%
 Lvl=-2,  PC=2, S=1, Star=0,  {**}  
 spouse(A, Alter), father(B, A), parent(Ego, B), female(Ego), female(Alter).
;; 296
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), female(Alter).
;; 297
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 298
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 299
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 300
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 301
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), parent(Ego, C), female(Ego), female(Alter).
;; 302
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), female(Alter).
;; 303
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), parent(Ego, D), female(Ego), female(Alter).
;; 304
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), female(Alter).
;; 305
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), parent(Ego, D), female(Ego), female(Alter).
;; 306
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), female(Alter).
;; 307
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 308
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 309
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 310
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 311
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), parent(Ego, C), female(Ego), female(Alter).
;; 312
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), female(Alter).
;; 313
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), parent(Ego, D), female(Ego), female(Alter).
;; 314
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), female(Alter).
;; 315
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), parent(Ego, D), female(Ego), female(Alter).
;; 316
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), female(Alter).
;; 317
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 318
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 319
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 320
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 321
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), parent(Ego, C), female(Ego), female(Alter).
;; 322
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), female(Alter).
;; 323
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), parent(Ego, D), female(Ego), female(Alter).
;; 324
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), female(Alter).
;; 325
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), parent(Ego, D), female(Ego), female(Alter).
;; 326
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), female(Alter).
;; 327
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 328
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 329
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), female(Alter).
;; 330
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), female(Alter).
;; 331
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), parent(Ego, C), female(Ego), female(Alter).
;; 332
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), female(Alter).
;; 333
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), parent(Ego, D), female(Ego), female(Alter).
;; 334
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), female(Alter).
;; 335
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), parent(Ego, D), female(Ego), female(Alter).
;; 336
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), female(Alter).
;; 337
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), parent(D, C), spouse(Ego, D), female(Ego), female(Alter).
;; 338
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), female(Alter).
;; 339
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Ego, E), female(Ego), female(Alter).
;; 340
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), female(Alter).
;; 341
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Ego, E), female(Ego), female(Alter).
;; 342
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), female(Alter).
;; 343
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), parent(D, C), spouse(Ego, D), female(Ego), female(Alter).
;; 344
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), female(Alter).
;; 345
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Ego, E), female(Ego), female(Alter).
;; 346
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), female(Alter).
;; 347
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), parent(E, D), spouse(Ego, E), female(Ego), female(Alter).
;; 348
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), female(Alter).
;; 349
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), parent(D, C), spouse(Ego, D), female(Ego), female(Alter).
;; 350
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), female(Alter).
;; 351
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Ego, E), female(Ego), female(Alter).
;; 352
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), female(Alter).
;; 353
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Ego, E), female(Ego), female(Alter).
;; 354
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), female(Alter).
;; 355
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), parent(D, C), spouse(Ego, D), female(Ego), female(Alter).
;; 356
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), female(Alter).
;; 357
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Ego, E), female(Ego), female(Alter).
;; 358
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), female(Alter).
;; 359
%parajico:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), parent(E, D), spouse(Ego, E), female(Ego), female(Alter).


parajicu(Alter, Ego) :-  grandparent[aux]10(Ego, Alter), male(Ego), male(Alter).
                     |   grandparent[aux]10(Ego, Alter), female(Ego), male(Alter).
{"**"}
;; 0
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:0, parents:0%
 Lvl=-2,  PC=2, S=0, Star=0,  {**}  
 mother(A, Alter), parent(Ego, A), male(Ego), male(Alter).
;; 1
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:0, parents:1%
 Lvl=-2,  PC=2, S=0, Star=0,  {**}  
 father(A, Alter), parent(Ego, A), male(Ego), male(Alter).
;; 2
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego), male(Alter).
;; 3
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), male(Alter).
;; 4
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), male(Alter).
;; 5
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), male(Alter).
;; 6
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), male(Alter).
;; 7
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), parent(Ego, B), male(Ego), male(Alter).
;; 8
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), male(Alter).
;; 9
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 10
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 11
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 12
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 13
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), parent(Ego, C), male(Ego), male(Alter).
;; 14
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), male(Alter).
;; 15
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 16
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 17
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 18
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 19
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), parent(Ego, C), male(Ego), male(Alter).
;; 20
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego), male(Alter).
;; 21
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), male(Alter).
;; 22
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), male(Alter).
;; 23
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), male(Alter).
;; 24
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), male(Alter).
;; 25
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), parent(Ego, B), male(Ego), male(Alter).
;; 26
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), male(Alter).
;; 27
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 28
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 29
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 30
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 31
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), parent(Ego, C), male(Ego), male(Alter).
;; 32
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), male(Alter).
;; 33
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 34
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 35
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 36
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 37
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), parent(Ego, C), male(Ego), male(Alter).
;; 38
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego), male(Alter).
;; 39
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), male(Alter).
;; 40
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), male(Alter).
;; 41
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), male(Alter).
;; 42
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), male(Alter).
;; 43
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), parent(Ego, B), male(Ego), male(Alter).
;; 44
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), male(Alter).
;; 45
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 46
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 47
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 48
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 49
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), parent(Ego, C), male(Ego), male(Alter).
;; 50
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), male(Alter).
;; 51
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 52
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 53
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 54
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 55
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), parent(Ego, C), male(Ego), male(Alter).
;; 56
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego), male(Alter).
;; 57
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), male(Alter).
;; 58
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), male(Alter).
;; 59
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Ego), male(Alter).
;; 60
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Ego), male(Alter).
;; 61
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), parent(Ego, B), male(Ego), male(Alter).
;; 62
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), male(Alter).
;; 63
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 64
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 65
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 66
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 67
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), parent(Ego, C), male(Ego), male(Alter).
;; 68
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), male(Alter).
;; 69
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 70
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 71
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 72
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 73
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), parent(Ego, C), male(Ego), male(Alter).
;; 74
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Ego), male(Alter).
;; 75
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 76
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 77
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 78
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 79
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), parent(C, B), spouse(Ego, C), male(Ego), male(Alter).
;; 80
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), male(Alter).
;; 81
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), parent(D, C), spouse(Ego, D), male(Ego), male(Alter).
;; 82
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), male(Alter).
;; 83
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), parent(D, C), spouse(Ego, D), male(Ego), male(Alter).
;; 84
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Ego), male(Alter).
;; 85
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 86
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 87
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 88
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 89
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), parent(C, B), spouse(Ego, C), male(Ego), male(Alter).
;; 90
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), male(Alter).
;; 91
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), parent(D, C), spouse(Ego, D), male(Ego), male(Alter).
;; 92
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), male(Alter).
;; 93
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), parent(D, C), spouse(Ego, D), male(Ego), male(Alter).
;; 94
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Ego), male(Alter).
;; 95
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 96
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 97
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 98
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 99
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), parent(C, B), spouse(Ego, C), male(Ego), male(Alter).
;; 100
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), male(Alter).
;; 101
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), parent(D, C), spouse(Ego, D), male(Ego), male(Alter).
;; 102
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), male(Alter).
;; 103
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), parent(D, C), spouse(Ego, D), male(Ego), male(Alter).
;; 104
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Ego), male(Alter).
;; 105
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 106
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 107
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 108
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Ego), male(Alter).
;; 109
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), parent(C, B), spouse(Ego, C), male(Ego), male(Alter).
;; 110
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), male(Alter).
;; 111
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), parent(D, C), spouse(Ego, D), male(Ego), male(Alter).
;; 112
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), male(Alter).
;; 113
%parajicu:0, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), parent(D, C), spouse(Ego, D), male(Ego), male(Alter).
;; 114
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:0, parents:0%
 Lvl=-2,  PC=2, S=1, Star=0,  {**}  
 spouse(A, Alter), mother(B, A), parent(Ego, B), male(Ego), male(Alter).
;; 115
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:0, parents:1%
 Lvl=-2,  PC=2, S=1, Star=0,  {**}  
 spouse(A, Alter), father(B, A), parent(Ego, B), male(Ego), male(Alter).
;; 116
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), male(Alter).
;; 117
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 118
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 119
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 120
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 121
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), parent(Ego, C), male(Ego), male(Alter).
;; 122
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), male(Alter).
;; 123
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), parent(Ego, D), male(Ego), male(Alter).
;; 124
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), male(Alter).
;; 125
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), parent(Ego, D), male(Ego), male(Alter).
;; 126
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), male(Alter).
;; 127
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 128
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 129
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 130
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 131
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), parent(Ego, C), male(Ego), male(Alter).
;; 132
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), male(Alter).
;; 133
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), parent(Ego, D), male(Ego), male(Alter).
;; 134
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), male(Alter).
;; 135
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), parent(Ego, D), male(Ego), male(Alter).
;; 136
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), male(Alter).
;; 137
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 138
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 139
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 140
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 141
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), parent(Ego, C), male(Ego), male(Alter).
;; 142
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), male(Alter).
;; 143
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), parent(Ego, D), male(Ego), male(Alter).
;; 144
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), male(Alter).
;; 145
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), parent(Ego, D), male(Ego), male(Alter).
;; 146
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Ego), male(Alter).
;; 147
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 148
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 149
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Ego), male(Alter).
;; 150
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Ego), male(Alter).
;; 151
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), parent(Ego, C), male(Ego), male(Alter).
;; 152
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), male(Alter).
;; 153
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), parent(Ego, D), male(Ego), male(Alter).
;; 154
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), male(Ego), male(Alter).
;; 155
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), parent(Ego, D), male(Ego), male(Alter).
;; 156
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), male(Alter).
;; 157
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), parent(D, C), spouse(Ego, D), male(Ego), male(Alter).
;; 158
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), male(Alter).
;; 159
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Ego, E), male(Ego), male(Alter).
;; 160
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), male(Alter).
;; 161
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Ego, E), male(Ego), male(Alter).
;; 162
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), male(Alter).
;; 163
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), parent(D, C), spouse(Ego, D), male(Ego), male(Alter).
;; 164
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), male(Alter).
;; 165
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Ego, E), male(Ego), male(Alter).
;; 166
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), male(Alter).
;; 167
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), parent(E, D), spouse(Ego, E), male(Ego), male(Alter).
;; 168
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), male(Alter).
;; 169
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), parent(D, C), spouse(Ego, D), male(Ego), male(Alter).
;; 170
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), male(Alter).
;; 171
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Ego, E), male(Ego), male(Alter).
;; 172
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), male(Alter).
;; 173
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Ego, E), male(Ego), male(Alter).
;; 174
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), male(Ego), male(Alter).
;; 175
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), parent(D, C), spouse(Ego, D), male(Ego), male(Alter).
;; 176
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), male(Alter).
;; 177
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Ego, E), male(Ego), male(Alter).
;; 178
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), male(Ego), male(Alter).
;; 179
%parajicu:0, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), parent(E, D), spouse(Ego, E), male(Ego), male(Alter).
;; 180
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:0, parents:0%
 Lvl=-2,  PC=2, S=0, Star=0,  {**}  
 mother(A, Alter), parent(Ego, A), female(Ego), male(Alter).
;; 181
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:0, parents:1%
 Lvl=-2,  PC=2, S=0, Star=0,  {**}  
 father(A, Alter), parent(Ego, A), female(Ego), male(Alter).
;; 182
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego), male(Alter).
;; 183
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), male(Alter).
;; 184
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), male(Alter).
;; 185
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), male(Alter).
;; 186
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), male(Alter).
;; 187
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), parent(Ego, B), female(Ego), male(Alter).
;; 188
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), male(Alter).
;; 189
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 190
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 191
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 192
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 193
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), parent(Ego, C), female(Ego), male(Alter).
;; 194
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), male(Alter).
;; 195
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 196
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 197
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 198
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 199
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), parent(Ego, C), female(Ego), male(Alter).
;; 200
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego), male(Alter).
;; 201
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), male(Alter).
;; 202
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), male(Alter).
;; 203
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), male(Alter).
;; 204
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), male(Alter).
;; 205
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), parent(Ego, B), female(Ego), male(Alter).
;; 206
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), male(Alter).
;; 207
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 208
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 209
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 210
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 211
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), parent(Ego, C), female(Ego), male(Alter).
;; 212
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), male(Alter).
;; 213
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 214
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 215
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 216
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 217
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), parent(Ego, C), female(Ego), male(Alter).
;; 218
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego), male(Alter).
;; 219
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), male(Alter).
;; 220
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), male(Alter).
;; 221
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), male(Alter).
;; 222
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), male(Alter).
;; 223
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), parent(Ego, B), female(Ego), male(Alter).
;; 224
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), male(Alter).
;; 225
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 226
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 227
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 228
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 229
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), parent(Ego, C), female(Ego), male(Alter).
;; 230
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), male(Alter).
;; 231
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 232
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 233
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 234
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 235
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), parent(Ego, C), female(Ego), male(Alter).
;; 236
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego), male(Alter).
;; 237
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), male(Alter).
;; 238
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), male(Alter).
;; 239
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Ego), male(Alter).
;; 240
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Ego), male(Alter).
;; 241
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), parent(Ego, B), female(Ego), male(Alter).
;; 242
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), male(Alter).
;; 243
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 244
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 245
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 246
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 247
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), parent(Ego, C), female(Ego), male(Alter).
;; 248
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), male(Alter).
;; 249
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 250
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 251
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 252
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 253
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), parent(Ego, C), female(Ego), male(Alter).
;; 254
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Ego), male(Alter).
;; 255
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 256
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 257
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 258
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 259
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), parent(C, B), spouse(Ego, C), female(Ego), male(Alter).
;; 260
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), male(Alter).
;; 261
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), parent(D, C), spouse(Ego, D), female(Ego), male(Alter).
;; 262
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), male(Alter).
;; 263
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), parent(D, C), spouse(Ego, D), female(Ego), male(Alter).
;; 264
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Ego), male(Alter).
;; 265
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 266
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 267
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 268
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 269
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), parent(C, B), spouse(Ego, C), female(Ego), male(Alter).
;; 270
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), male(Alter).
;; 271
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), parent(D, C), spouse(Ego, D), female(Ego), male(Alter).
;; 272
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), male(Alter).
;; 273
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  mother(A, Alter), father(B, A), father(C, B), parent(D, C), spouse(Ego, D), female(Ego), male(Alter).
;; 274
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Ego), male(Alter).
;; 275
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 276
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 277
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 278
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 279
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), parent(C, B), spouse(Ego, C), female(Ego), male(Alter).
;; 280
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), male(Alter).
;; 281
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), parent(D, C), spouse(Ego, D), female(Ego), male(Alter).
;; 282
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), male(Alter).
;; 283
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), mother(B, A), father(C, B), parent(D, C), spouse(Ego, D), female(Ego), male(Alter).
;; 284
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Ego), male(Alter).
;; 285
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 286
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 287
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 288
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Ego), male(Alter).
;; 289
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), parent(C, B), spouse(Ego, C), female(Ego), male(Alter).
;; 290
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), male(Alter).
;; 291
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), mother(C, B), parent(D, C), spouse(Ego, D), female(Ego), male(Alter).
;; 292
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), male(Alter).
;; 293
%parajicu:1, grandparent[aux]10:0, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  father(A, Alter), father(B, A), father(C, B), parent(D, C), spouse(Ego, D), female(Ego), male(Alter).
;; 294
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:0, parents:0%
 Lvl=-2,  PC=2, S=1, Star=0,  {**}  
 spouse(A, Alter), mother(B, A), parent(Ego, B), female(Ego), male(Alter).
;; 295
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:0, parents:1%
 Lvl=-2,  PC=2, S=1, Star=0,  {**}  
 spouse(A, Alter), father(B, A), parent(Ego, B), female(Ego), male(Alter).
;; 296
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), male(Alter).
;; 297
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 298
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 299
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 300
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 301
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), parent(Ego, C), female(Ego), male(Alter).
;; 302
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), male(Alter).
;; 303
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), parent(Ego, D), female(Ego), male(Alter).
;; 304
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), male(Alter).
;; 305
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), parent(Ego, D), female(Ego), male(Alter).
;; 306
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), male(Alter).
;; 307
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 308
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 309
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 310
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 311
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), parent(Ego, C), female(Ego), male(Alter).
;; 312
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), male(Alter).
;; 313
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), parent(Ego, D), female(Ego), male(Alter).
;; 314
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), male(Alter).
;; 315
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), parent(Ego, D), female(Ego), male(Alter).
;; 316
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), male(Alter).
;; 317
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 318
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 319
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 320
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 321
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), parent(Ego, C), female(Ego), male(Alter).
;; 322
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), male(Alter).
;; 323
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), parent(Ego, D), female(Ego), male(Alter).
;; 324
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), male(Alter).
;; 325
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), parent(Ego, D), female(Ego), male(Alter).
;; 326
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Ego), male(Alter).
;; 327
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 328
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 329
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Ego), male(Alter).
;; 330
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Ego), male(Alter).
;; 331
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), parent(Ego, C), female(Ego), male(Alter).
;; 332
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), male(Alter).
;; 333
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), parent(Ego, D), female(Ego), male(Alter).
;; 334
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Ego, E), child(Ego, F), not(equal(Ego, D)), female(Ego), male(Alter).
;; 335
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:1, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), parent(Ego, D), female(Ego), male(Alter).
;; 336
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), male(Alter).
;; 337
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), parent(D, C), spouse(Ego, D), female(Ego), male(Alter).
;; 338
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), male(Alter).
;; 339
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Ego, E), female(Ego), male(Alter).
;; 340
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), male(Alter).
;; 341
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Ego, E), female(Ego), male(Alter).
;; 342
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), male(Alter).
;; 343
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), parent(D, C), spouse(Ego, D), female(Ego), male(Alter).
;; 344
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), male(Alter).
;; 345
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Ego, E), female(Ego), male(Alter).
;; 346
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), male(Alter).
;; 347
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:0, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), mother(B, A), father(C, B), father(D, C), parent(E, D), spouse(Ego, E), female(Ego), male(Alter).
;; 348
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), male(Alter).
;; 349
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), parent(D, C), spouse(Ego, D), female(Ego), male(Alter).
;; 350
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), male(Alter).
;; 351
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), parent(E, D), spouse(Ego, E), female(Ego), male(Alter).
;; 352
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), male(Alter).
;; 353
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:0, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), mother(C, B), father(D, C), parent(E, D), spouse(Ego, E), female(Ego), male(Alter).
;; 354
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-2,  PC=6, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Ego, F), female(Ego), male(Alter).
;; 355
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:1%
 Lvl=-3,  PC=3, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), parent(D, C), spouse(Ego, D), female(Ego), male(Alter).
;; 356
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), male(Alter).
;; 357
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), mother(D, C), parent(E, D), spouse(Ego, E), female(Ego), male(Alter).
;; 358
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=-3,  PC=7, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), spouse(Ego, G), female(Ego), male(Alter).
;; 359
%parajicu:1, grandparent[aux]10:1, grandparent[aux]10direct:2, parents:1, parents:1, square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=-4,  PC=4, S=2, Star=0,  {**}  
[ext],  spouse(A, Alter), father(B, A), father(C, B), father(D, C), parent(E, D), spouse(Ego, E), female(Ego), male(Alter).


parallel_gen[aux]10(Alter, Ego) :-  sibling(Alter, Ego), gender(A, Alter), gender(A, Ego).
                                |  [ext],  parents(A, Ego), parallel_gen[aux]10(B, A), child(Alter, B), gender(C, Alter), gender(C, Ego).
                                |  [ext],  step_child[aux]10(Ego, A), child(Alter, A), gender(B, Alter), gender(B, Ego).
                                |  [ext],  step_child[aux]10(Ego, A), parallel_gen[aux]10(B, A), child(Alter, B), gender(C, Alter), gender(C, Ego).
;; 0
%parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 male(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Alter), gender(C, Ego).
;; 1
%parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), child(Alter, D), gender(F, Alter), gender(F, Ego).
;; 2
%parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Alter, E), gender(G, Alter), gender(G, Ego).
;; 3
%parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Alter, E), gender(G, Alter), gender(G, Ego).
;; 4
%parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), child(Alter, D), gender(F, Alter), gender(F, Ego).
;; 5
%parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Alter, E), gender(G, Alter), gender(G, Ego).
;; 6
%parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Alter, E), gender(G, Alter), gender(G, Ego).
;; 7
%parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(Alter, B), gender(D, Alter), gender(D, Ego).
;; 8
%parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(Alter, B), gender(D, Alter), gender(D, Ego).
;; 9
%parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(Alter, F), gender(H, Alter), gender(H, Ego).
;; 10
%parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), husband(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Alter, G), gender(I, Alter), gender(I, Ego).
;; 11
%parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), wife(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Alter, G), gender(I, Alter), gender(I, Ego).
;; 12
%parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(Alter, F), gender(H, Alter), gender(H, Ego).
;; 13
%parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), husband(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Alter, G), gender(I, Alter), gender(I, Ego).
;; 14
%parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), wife(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Alter, G), gender(I, Alter), gender(I, Ego).
;; 15
%parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 female(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Alter), gender(C, Ego).
;; 16
%parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), child(Alter, D), gender(F, Alter), gender(F, Ego).
;; 17
%parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Alter, E), gender(G, Alter), gender(G, Ego).
;; 18
%parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Alter, E), gender(G, Alter), gender(G, Ego).
;; 19
%parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), child(Alter, D), gender(F, Alter), gender(F, Ego).
;; 20
%parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Alter, E), gender(G, Alter), gender(G, Ego).
;; 21
%parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), child(Alter, E), gender(G, Alter), gender(G, Ego).
;; 22
%parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(Alter, B), gender(D, Alter), gender(D, Ego).
;; 23
%parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), child(Alter, B), gender(D, Alter), gender(D, Ego).
;; 24
%parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(Alter, F), gender(H, Alter), gender(H, Ego).
;; 25
%parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), husband(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Alter, G), gender(I, Alter), gender(I, Ego).
;; 26
%parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), husband(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), wife(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Alter, G), gender(I, Alter), gender(I, Ego).
;; 27
%parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), mother(D, B), father(E, B), child(F, D), child(F, E), not(equal(F, B)), gender(G, F), gender(G, B), child(Alter, F), gender(H, Alter), gender(H, Ego).
;; 28
%parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), husband(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Alter, G), gender(I, Alter), gender(I, Ego).
;; 29
%parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), wife(A, B), spouse(C, A), not(equal(B, C)), child(Ego, C), child(Ego, A), wife(D, E), spouse(F, D), not(equal(E, F)), child(B, F), child(B, D), child(G, E), gender(H, G), gender(H, B), child(Alter, G), gender(I, Alter), gender(I, Ego).


parents(Alter, Ego) :-  mother(Alter, Ego).
                    |   father(Alter, Ego).
;; 0
%parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(Alter, Ego).
;; 1
%parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(Alter, Ego).


pari_mo(Alter, Ego) :-  spice(A, Ego), mother(Alter, A).
                    |  [ext],  spice(A, Ego), step_mother(Alter, A).
                    |  [ext],  spice(A, Ego), parents(B, A), generation[aux]10(Alter, B), female(Alter).
                    |  [ext],  spice(A, Ego), step_father(B, A), generation[aux]10(Alter, B), female(Alter).
{"**"}
;; 0
%pari_mo:0, spice:0%
 Lvl=1,  PC=1, S=1, Star=0,  {**}  
 husband(A, Ego), mother(Alter, A).
;; 1
%pari_mo:0, spice:1%
 Lvl=1,  PC=1, S=1, Star=0,  {**}  
 wife(A, Ego), mother(Alter, A).
;; 2
%pari_mo:1, spice:0, step_mother:0%
 Lvl=1,  PC=2, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), wife(Alter, B), not(equal(Alter, C)).
;; 3
%pari_mo:1, spice:1, step_mother:0%
 Lvl=1,  PC=2, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), wife(Alter, B), not(equal(Alter, C)).
;; 4
%pari_mo:2, spice:0, parents:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 5
%pari_mo:2, spice:0, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 6
%pari_mo:2, spice:0, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 7
%pari_mo:2, spice:0, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 8
%pari_mo:2, spice:0, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 9
%pari_mo:2, spice:0, parents:1, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 10
%pari_mo:2, spice:0, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 11
%pari_mo:2, spice:0, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 12
%pari_mo:2, spice:0, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 13
%pari_mo:2, spice:0, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 14
%pari_mo:2, spice:1, parents:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 15
%pari_mo:2, spice:1, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 16
%pari_mo:2, spice:1, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 17
%pari_mo:2, spice:1, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 18
%pari_mo:2, spice:1, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 19
%pari_mo:2, spice:1, parents:1, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 20
%pari_mo:2, spice:1, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 21
%pari_mo:2, spice:1, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 22
%pari_mo:2, spice:1, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 23
%pari_mo:2, spice:1, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 24
%pari_mo:3, spice:0, step_father:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 25
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), female(Alter).
;; 26
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), female(Alter).
;; 27
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 28
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 29
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 30
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).
;; 31
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 32
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 33
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 34
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).
;; 35
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), female(Alter).
;; 36
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), female(Alter).
;; 37
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 38
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 39
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 40
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).
;; 41
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 42
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 43
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 44
%pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).
;; 45
%pari_mo:3, spice:1, step_father:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 46
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), female(Alter).
;; 47
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), female(Alter).
;; 48
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 49
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 50
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 51
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).
;; 52
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 53
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 54
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 55
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).
;; 56
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), female(Alter).
;; 57
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), female(Alter).
;; 58
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 59
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 60
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 61
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).
;; 62
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 63
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 64
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 65
%pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).


pari_yo(Alter, Ego) :-  spice(A, Ego), father(Alter, A).
                    |  [ext],  spice(A, Ego), step_father(Alter, A).
                    |  [ext],  spice(A, Ego), parents(B, A), generation[aux]10(Alter, B), male(Alter).
                    |  [ext],  spice(A, Ego), step_father(B, A), generation[aux]10(Alter, B), male(Alter).
{"**"}
;; 0
%pari_yo:0, spice:0%
 Lvl=1,  PC=1, S=1, Star=0,  {**}  
 husband(A, Ego), father(Alter, A).
;; 1
%pari_yo:0, spice:1%
 Lvl=1,  PC=1, S=1, Star=0,  {**}  
 wife(A, Ego), father(Alter, A).
;; 2
%pari_yo:1, spice:0, step_father:0%
 Lvl=1,  PC=2, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(Alter, C), not(equal(Alter, B)).
;; 3
%pari_yo:1, spice:1, step_father:0%
 Lvl=1,  PC=2, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(Alter, C), not(equal(Alter, B)).
;; 4
%pari_yo:2, spice:0, parents:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 5
%pari_yo:2, spice:0, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 6
%pari_yo:2, spice:0, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 7
%pari_yo:2, spice:0, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 8
%pari_yo:2, spice:0, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 9
%pari_yo:2, spice:0, parents:1, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 10
%pari_yo:2, spice:0, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 11
%pari_yo:2, spice:0, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 12
%pari_yo:2, spice:0, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 13
%pari_yo:2, spice:0, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 14
%pari_yo:2, spice:1, parents:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 15
%pari_yo:2, spice:1, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 16
%pari_yo:2, spice:1, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 17
%pari_yo:2, spice:1, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 18
%pari_yo:2, spice:1, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 19
%pari_yo:2, spice:1, parents:1, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 20
%pari_yo:2, spice:1, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 21
%pari_yo:2, spice:1, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 22
%pari_yo:2, spice:1, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 23
%pari_yo:2, spice:1, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 24
%pari_yo:3, spice:0, step_father:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 25
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), male(Alter).
;; 26
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), male(Alter).
;; 27
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 28
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 29
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 30
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).
;; 31
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 32
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 33
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 34
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).
;; 35
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), male(Alter).
;; 36
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), male(Alter).
;; 37
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 38
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 39
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 40
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).
;; 41
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 42
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 43
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 44
%pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).
;; 45
%pari_yo:3, spice:1, step_father:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 46
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), male(Alter).
;; 47
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), male(Alter).
;; 48
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 49
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 50
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 51
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).
;; 52
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 53
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 54
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 55
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).
;; 56
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), male(Alter).
;; 57
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), male(Alter).
;; 58
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 59
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 60
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 61
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).
;; 62
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 63
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 64
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 65
%pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).


parimo(Alter, Ego) :-  father(A, Ego), cross_gen[aux]10(Alter, A), female(Alter).
                   |   father(A, Ego), parallel_gen[aux]10(B, A), wife(Alter, B).
                   |   pari_mo(Alter, Ego).
{"**_FaBroWi_FaHbroWi"}
;; 0
%parimo:0, cross_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=0, Star=0,  {**}  
 father(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), gender(D, A), gender(E, Alter), not(equal(D, E)), female(Alter).
;; 1
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:0, parents:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), female(Alter).
;; 2
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:0, parents:1, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), female(Alter).
;; 3
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 4
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 5
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 6
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 7
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), female(Alter).
;; 8
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), female(Alter).
;; 9
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 10
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 11
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 12
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), mother(B, A), father(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 13
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), father(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), female(Alter).
;; 14
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), father(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), female(Alter).
;; 15
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 16
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 17
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 18
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), mother(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 19
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), female(Alter).
;; 20
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), female(Alter).
;; 21
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 22
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 23
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 24
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  father(A, Ego), father(B, A), father(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), female(Alter).
;; 25
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), father(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), female(Alter).
;; 26
%parimo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), father(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), female(Alter).
;; 27
%parimo:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {FaBroWi}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), wife(Alter, D).
;; 28
%parimo:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(G, E), gender(H, G), gender(H, A), wife(Alter, G).
;; 29
%parimo:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), wife(Alter, H).
;; 30
%parimo:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext],  father(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), wife(Alter, H).
;; 31
%parimo:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(G, E), gender(H, G), gender(H, A), wife(Alter, G).
;; 32
%parimo:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), wife(Alter, H).
;; 33
%parimo:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext],  father(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), wife(Alter, H).
;; 34
%parimo:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=4, S=3, Star=0,  {FaHbroWi}  
[ext],  father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), wife(Alter, E).
;; 35
%parimo:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=4, S=3, Star=0,  {FaHbroWi}  
[ext],  father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), wife(Alter, E).
;; 36
%parimo:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=8, S=3, Star=0,  {**}  
[ext],  father(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(I, G), gender(J, I), gender(J, A), wife(Alter, I).
;; 37
%parimo:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=8, S=3, Star=0,  {**}  
[ext],  father(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(I, G), gender(J, I), gender(J, A), wife(Alter, I).
;; 38
%parimo:2, pari_mo:0, spice:0%
 Lvl=1,  PC=1, S=1, Star=0,  {**}  
 husband(A, Ego), mother(Alter, A).
;; 39
%parimo:2, pari_mo:0, spice:1%
 Lvl=1,  PC=1, S=1, Star=0,  {**}  
 wife(A, Ego), mother(Alter, A).
;; 40
%parimo:2, pari_mo:1, spice:0, step_mother:0%
 Lvl=1,  PC=2, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), wife(Alter, B), not(equal(Alter, C)).
;; 41
%parimo:2, pari_mo:1, spice:1, step_mother:0%
 Lvl=1,  PC=2, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), wife(Alter, B), not(equal(Alter, C)).
;; 42
%parimo:2, pari_mo:2, spice:0, parents:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 43
%parimo:2, pari_mo:2, spice:0, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 44
%parimo:2, pari_mo:2, spice:0, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 45
%parimo:2, pari_mo:2, spice:0, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 46
%parimo:2, pari_mo:2, spice:0, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 47
%parimo:2, pari_mo:2, spice:0, parents:1, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 48
%parimo:2, pari_mo:2, spice:0, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 49
%parimo:2, pari_mo:2, spice:0, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 50
%parimo:2, pari_mo:2, spice:0, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 51
%parimo:2, pari_mo:2, spice:0, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 52
%parimo:2, pari_mo:2, spice:1, parents:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 53
%parimo:2, pari_mo:2, spice:1, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 54
%parimo:2, pari_mo:2, spice:1, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 55
%parimo:2, pari_mo:2, spice:1, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 56
%parimo:2, pari_mo:2, spice:1, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 57
%parimo:2, pari_mo:2, spice:1, parents:1, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 58
%parimo:2, pari_mo:2, spice:1, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 59
%parimo:2, pari_mo:2, spice:1, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 60
%parimo:2, pari_mo:2, spice:1, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 61
%parimo:2, pari_mo:2, spice:1, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 62
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 63
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), female(Alter).
;; 64
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), female(Alter).
;; 65
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 66
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 67
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 68
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).
;; 69
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 70
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 71
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 72
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).
;; 73
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), female(Alter).
;; 74
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), female(Alter).
;; 75
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 76
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 77
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 78
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).
;; 79
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 80
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 81
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 82
%parimo:2, pari_mo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).
;; 83
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 84
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), female(Alter).
;; 85
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), female(Alter).
;; 86
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 87
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 88
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 89
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).
;; 90
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 91
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 92
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 93
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).
;; 94
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), female(Alter).
;; 95
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), female(Alter).
;; 96
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 97
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 98
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 99
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).
;; 100
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), female(Alter).
;; 101
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), female(Alter).
;; 102
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), female(Alter).
;; 103
%parimo:2, pari_mo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), female(Alter).


pariyo(Alter, Ego) :-  mother(A, Ego), cross_gen[aux]10(Alter, A), male(Alter).
                   |   mother(A, Ego), parallel_gen[aux]10(B, A), husband(Alter, B).
                   |   pari_yo(Alter, Ego).
{"**_MoHsisHu_MoSisHu"}
;; 0
%pariyo:0, cross_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=0, Star=0,  {**}  
 mother(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), gender(D, A), gender(E, Alter), not(equal(D, E)), male(Alter).
;; 1
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:0, parents:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), male(Alter).
;; 2
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:0, parents:1, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), male(Alter).
;; 3
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 4
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 5
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 6
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 7
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), male(Alter).
;; 8
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), male(Alter).
;; 9
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 10
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 11
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 12
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 13
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), father(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), male(Alter).
;; 14
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:0, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), father(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), male(Alter).
;; 15
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 16
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 17
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 18
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 19
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), male(Alter).
;; 20
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), male(Alter).
;; 21
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 22
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 23
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, B), father(D, E), husband(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 24
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext], [ext], [ext],  mother(A, Ego), father(B, A), father(C, B), father(D, E), wife(F, G), spouse(H, F), not(equal(G, H)), child(D, H), child(D, F), child(I, G), gender(J, I), gender(J, D), child(C, I), gender(K, C), gender(K, E), child(L, E), child(Alter, L), gender(M, B), gender(N, L), not(equal(M, N)), male(Alter).
;; 25
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), father(C, B), husband(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), male(Alter).
;; 26
%pariyo:0, cross_gen[aux]10:1, cross_gen[aux]102:2, parents:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), father(C, B), wife(D, E), spouse(F, D), not(equal(E, F)), child(G, F), child(G, D), child(C, E), gender(H, C), gender(H, G), child(I, G), child(Alter, I), gender(J, B), gender(K, I), not(equal(J, K)), male(Alter).
;; 27
%pariyo:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {MoSisHu}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, D), gender(E, A), husband(Alter, D).
;; 28
%pariyo:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(G, E), gender(H, G), gender(H, A), husband(Alter, G).
;; 29
%pariyo:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), husband(Alter, H).
;; 30
%pariyo:1, parallel_gen[aux]10:1, parents:0, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), mother(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), husband(Alter, H).
;; 31
%pariyo:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, E), gender(F, B), child(G, E), gender(H, G), gender(H, A), husband(Alter, G).
;; 32
%pariyo:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), husband(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), husband(Alter, H).
;; 33
%pariyo:1, parallel_gen[aux]10:1, parents:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=6, S=3, Star=0,  {**}  
[ext], [ext],  mother(A, Ego), father(B, A), wife(C, D), spouse(E, C), not(equal(D, E)), child(B, E), child(B, C), child(F, D), gender(G, F), gender(G, B), child(H, F), gender(I, H), gender(I, A), husband(Alter, H).
;; 34
%pariyo:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:0%
 Lvl=1,  PC=4, S=3, Star=0,  {MoHsisHu}  
[ext],  mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), husband(Alter, E).
;; 35
%pariyo:1, parallel_gen[aux]10:2, step_child[aux]10:0, spice:1%
 Lvl=1,  PC=4, S=3, Star=0,  {MoHsisHu}  
[ext],  mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), child(E, C), gender(F, E), gender(F, A), husband(Alter, E).
;; 36
%pariyo:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:0, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=8, S=3, Star=0,  {**}  
[ext],  mother(A, Ego), husband(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(I, G), gender(J, I), gender(J, A), husband(Alter, I).
;; 37
%pariyo:1, parallel_gen[aux]10:3, step_child[aux]10:0, spice:1, parallel_gen[aux]10:0, sibling:0%
 Lvl=1,  PC=8, S=3, Star=0,  {**}  
[ext],  mother(A, Ego), wife(B, C), spouse(D, B), not(equal(C, D)), child(A, D), child(A, B), mother(E, C), father(F, C), child(G, E), child(G, F), not(equal(G, C)), gender(H, G), gender(H, C), child(I, G), gender(J, I), gender(J, A), husband(Alter, I).
;; 38
%pariyo:2, pari_yo:0, spice:0%
 Lvl=1,  PC=1, S=1, Star=0,  {**}  
 husband(A, Ego), father(Alter, A).
;; 39
%pariyo:2, pari_yo:0, spice:1%
 Lvl=1,  PC=1, S=1, Star=0,  {**}  
 wife(A, Ego), father(Alter, A).
;; 40
%pariyo:2, pari_yo:1, spice:0, step_father:0%
 Lvl=1,  PC=2, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(Alter, C), not(equal(Alter, B)).
;; 41
%pariyo:2, pari_yo:1, spice:1, step_father:0%
 Lvl=1,  PC=2, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(Alter, C), not(equal(Alter, B)).
;; 42
%pariyo:2, pari_yo:2, spice:0, parents:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 43
%pariyo:2, pari_yo:2, spice:0, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 44
%pariyo:2, pari_yo:2, spice:0, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 45
%pariyo:2, pari_yo:2, spice:0, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 46
%pariyo:2, pari_yo:2, spice:0, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 47
%pariyo:2, pari_yo:2, spice:0, parents:1, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 48
%pariyo:2, pari_yo:2, spice:0, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 49
%pariyo:2, pari_yo:2, spice:0, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 50
%pariyo:2, pari_yo:2, spice:0, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 51
%pariyo:2, pari_yo:2, spice:0, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 52
%pariyo:2, pari_yo:2, spice:1, parents:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 53
%pariyo:2, pari_yo:2, spice:1, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 54
%pariyo:2, pari_yo:2, spice:1, parents:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 55
%pariyo:2, pari_yo:2, spice:1, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 56
%pariyo:2, pari_yo:2, spice:1, parents:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 57
%pariyo:2, pari_yo:2, spice:1, parents:1, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 58
%pariyo:2, pari_yo:2, spice:1, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 59
%pariyo:2, pari_yo:2, spice:1, parents:1, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 60
%pariyo:2, pari_yo:2, spice:1, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 61
%pariyo:2, pari_yo:2, spice:1, parents:1, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 62
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 63
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), male(Alter).
;; 64
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), male(Alter).
;; 65
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 66
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 67
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 68
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).
;; 69
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 70
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 71
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 72
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).
;; 73
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), male(Alter).
;; 74
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), male(Alter).
;; 75
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 76
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 77
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 78
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).
;; 79
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 80
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 81
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 82
%pariyo:2, pari_yo:3, spice:0, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  husband(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).
;; 83
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:0, sibling:0%
 Lvl=1,  PC=6, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 84
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), male(Alter).
;; 85
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), male(Alter).
;; 86
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 87
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 88
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 89
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).
;; 90
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 91
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 92
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 93
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), mother(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).
;; 94
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), male(H), child(Alter, H), male(Alter).
;; 95
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=8, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), father(G, E), child(H, F), child(H, G), not(equal(H, E)), female(H), child(Alter, H), male(Alter).
;; 96
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 97
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 98
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 99
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), mother(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).
;; 100
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), son(J, I), child(Alter, J), male(Alter).
;; 101
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), male(I), daughter(J, I), child(Alter, J), male(Alter).
;; 102
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), son(J, I), child(Alter, J), male(Alter).
;; 103
%pariyo:2, pari_yo:3, spice:1, step_father:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=10, S=2, Star=0,  {**}  
[ext],  wife(A, Ego), father(B, A), mother(C, A), husband(D, C), not(equal(D, B)), father(E, D), father(F, E), mother(G, F), father(H, F), child(I, G), child(I, H), not(equal(I, F)), female(I), daughter(J, I), child(Alter, J), male(Alter).


sibling(Alter, Ego) :-  mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).
;; 0
%sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).


siblings(Alter, Ego) :-  brother(Alter, Ego).
                     |   sister(Alter, Ego).
;; 0
%siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter).
;; 1
%siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter).


sister(Alter, Ego) :-  sibling(Alter, Ego), female(Alter).
;; 0
%sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter).


spice(Alter, Ego) :-  husband(Alter, Ego).
                  |   wife(Alter, Ego).
;; 0
%spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(Alter, Ego).
;; 1
%spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 wife(Alter, Ego).


square[aux]10up(Alter, Ego) :-  generation[aux]10(Alter, Ego).
                            |   parent(Alter, Ego).
                            |   parents(A, Ego), square[aux]10up(Alter, A).
;; 0
%square[aux]10up:0, generation[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).
;; 1
%square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 2
%square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 3
%square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 4
%square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 5
%square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 6
%square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 7
%square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 8
%square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 9
%square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 10
%square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 11
%square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 12
%square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 13
%square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 14
%square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 15
%square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 16
%square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 17
%square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 18
%square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 19
%square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 20
%square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 21
%square[aux]10up:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 parent(Alter, Ego).
;; 22
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)).
;; 23
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 24
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 25
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 26
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 27
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 28
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 29
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 30
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 31
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 32
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 33
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 34
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 35
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 36
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 37
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 38
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 39
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 40
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 41
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 42
%square[aux]10up:2, parents:0, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 43
%square[aux]10up:2, parents:0, square[aux]10up:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), parent(Alter, A).
;; 44
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)).
;; 45
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 46
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 47
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 48
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 49
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 50
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 51
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 52
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 53
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 54
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:0, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 55
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 56
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 57
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 58
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 59
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 60
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:0, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 61
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 62
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 63
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 64
%square[aux]10up:2, parents:1, square[aux]10up:0, generation[aux]10:1, parents:1, generation[aux]10gs:1, parents:1, generation[aux]10gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 65
%square[aux]10up:2, parents:1, square[aux]10up:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), parent(Alter, A).


square[aux]10up_small(Alter, Ego) :-  generation[aux]10small(Alter, Ego).
                                  |   parent(Alter, Ego).
                                  |   parents(A, Ego), square[aux]10up_small(Alter, A).
;; 0
%square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).
;; 1
%square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 2
%square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 3
%square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 4
%square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 5
%square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 parent(Alter, Ego).
;; 6
%square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)).
;; 7
%square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 8
%square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 9
%square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 10
%square[aux]10up_small:2, parents:0, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 11
%square[aux]10up_small:2, parents:0, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), parent(Alter, A).
;; 12
%square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)).
;; 13
%square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 14
%square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 15
%square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 16
%square[aux]10up_small:2, parents:1, square[aux]10up_small:0, generation[aux]10small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 17
%square[aux]10up_small:2, parents:1, square[aux]10up_small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), parent(Alter, A).


step_brother(Alter, Ego) :-  father(A, Ego), mother(B, Ego), husband(C, B), not(equal(C, A)), wife(D, C), not(equal(D, B)), son(Alter, D), son(Alter, C).
                         |   father(A, Ego), mother(B, Ego), wife(C, A), not(equal(C, B)), husband(D, C), not(equal(D, A)), son(Alter, D), son(Alter, C).
;; 0
%step_brother:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), husband(C, B), not(equal(C, A)), wife(D, C), not(equal(D, B)), son(Alter, D), son(Alter, C).
;; 1
%step_brother:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), wife(C, A), not(equal(C, B)), husband(D, C), not(equal(D, A)), son(Alter, D), son(Alter, C).


step_child[aux]10(Alter, Ego) :-  spice(A, Ego), spouse(B, A), not(equal(Ego, B)), child(Alter, B), child(Alter, A).
;; 0
%step_child[aux]10:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(A, Ego), spouse(B, A), not(equal(Ego, B)), child(Alter, B), child(Alter, A).
;; 1
%step_child[aux]10:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 wife(A, Ego), spouse(B, A), not(equal(Ego, B)), child(Alter, B), child(Alter, A).


step_daughter(Alter, Ego) :-  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(Alter, B), daughter(Alter, A).
;; 0
%step_daughter:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(Alter, B), daughter(Alter, A).


step_father(Alter, Ego) :-  father(A, Ego), mother(B, Ego), husband(Alter, B), not(equal(Alter, A)).
;; 0
%step_father:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), husband(Alter, B), not(equal(Alter, A)).


step_mother(Alter, Ego) :-  father(A, Ego), mother(B, Ego), wife(Alter, A), not(equal(Alter, B)).
;; 0
%step_mother:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), wife(Alter, A), not(equal(Alter, B)).


step_sister(Alter, Ego) :-  father(A, Ego), mother(B, Ego), husband(C, B), not(equal(C, A)), wife(D, C), not(equal(D, B)), daughter(Alter, D), daughter(Alter, C).
                        |   father(A, Ego), mother(B, Ego), wife(C, A), not(equal(C, B)), husband(D, C), not(equal(D, A)), daughter(Alter, D), daughter(Alter, C).
;; 0
%step_sister:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), husband(C, B), not(equal(C, A)), wife(D, C), not(equal(D, B)), daughter(Alter, D), daughter(Alter, C).
;; 1
%step_sister:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), wife(C, A), not(equal(C, B)), husband(D, C), not(equal(D, A)), daughter(Alter, D), daughter(Alter, C).


step_son(Alter, Ego) :-  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(Alter, B), son(Alter, A).
;; 0
%step_son:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(Alter, B), son(Alter, A).


yure_buwado(Alter, Ego) :-  step_mother(Alter, Ego).
{"Stmo"}
;; 0
%yure_buwado:0, step_mother:0%
 Lvl=1,  PC=2, S=1, Star=0,  {Stmo}  
 father(A, Ego), mother(B, Ego), wife(Alter, A), not(equal(Alter, B)).


yure_buwayu(Alter, Ego) :-  step_father(Alter, Ego).
{"Stfa"}
;; 0
%yure_buwayu:0, step_father:0%
 Lvl=1,  PC=2, S=1, Star=0,  {Stfa}  
 father(A, Ego), mother(B, Ego), husband(Alter, B), not(equal(Alter, A)).

